SystemOrganization addCategory: #'MS-info10-ProfStef'!

AbstractTutorial subclass: #ObjekteKlassenTutorial
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MS-info10-ProfStef'!

!ObjekteKlassenTutorial commentStamp: '<historical>' prior: 0!
Eine Einfhrung in den Umgang mit den wichtigsten Programmierwerkzeugen.
Start mit:

ProfStef goOn: ObjekteKlassenTutorial.

Oder mit 

ProfStefBrowser goOn: ObjekteKlassenTutorial.
!

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/31/2010 14:34'!
zeigeKategorienInBrowser
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche klasse |
	klasse := EllipseMorph.
	browser := OBSystemBrowser onClass:  klasse.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	"browserfenster := browser topView."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 1) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/31/2010 14:33'!
zeigeKategorienInBrowser: klasse 
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche |
	"klasse := EllipseMorph"
	browser := OBSystemBrowser onClass:  klasse.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	"browserfenster := browser topView."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 1) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:05'!
zeigeKlassenInBrowser
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche klasse |
	klasse := EllipseMorph.
	browser := OBSystemBrowser onClass:  klasse.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 3) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:05'!
zeigeKlassenInBrowser: klasse 
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche |
	"klasse := EllipseMorph."
	browser := OBSystemBrowser onClass:  klasse.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 3) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:06'!
zeigeMethodenInBrowser
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche klasse methode|
	klasse := EllipseMorph.
	methode := 'defaultColor'.
	browser := OBSystemBrowser onClass:  klasse selector: methode.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 7) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:06'!
zeigeMethodenInBrowser: klasse mitMethode: methode 
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche |
	"klasse := EllipseMorph.
	methode := 'defaultColor'."
	browser := OBSystemBrowser onClass:  klasse selector: methode.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 7) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 19:27'!
zeigePongSkizze
	"zeigt ein Spielfeld fr Pong mit Ball und Schlger"
	| feld schlaeger ball textp textf button |
	feld := PasteUpMorph new.
	feld extent: 300@200; openInWindowLabeled: 'Mein Pong'; color: Color black.
	"feld extent: 300@200; openInWorld; color: Color black."
	ball := EllipseMorph new extent: 30@30; borderColor: Color white; color: Color green; openInWorld: feld; position: feld position + (120@30).
	schlaeger := RectangleMorph new extent: 100@15; borderColor: Color orange; color: Color red; openInWorld: feld; position: feld position +(150@180).
	textp := TextMorph new contents: 'Punkte:', Character tab asString, ' 13'; color: Color white; openInWorld: feld; position: feld position + (10@5).	
	textf := TextMorph new contents: 'Fehler:', Character tab asString, ' 2/5'; color: Color white; openInWorld: feld; position: feld position + (10@20).
	button := SimpleButtonMorph new label: 'Start/Stop'; useRoundedCorners;  openInWorld: feld; position: feld position + (220@5).! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:06'!
zeigeProtokolleInBrowser
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche klasse protokoll |
	klasse := EllipseMorph.
	protokoll :=  'geometry'.
	browser := OBSystemBrowser onClass:  klasse category: protokoll.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 5) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial class methodsFor: 'showcase' stamp: 'MarkusSchlager 12/30/2010 23:06'!
zeigeProtokolleInBrowser: klasse mitProtokoll: protokoll 
	"zeige ein Browserfenster mit eingerahmter Kategorienliste"
	| browser browserfenster browserbereiche |
	"klasse := EllipseMorph.
	protokoll :=  'geometry'."
	browser := OBSystemBrowser onClass:  klasse category: protokoll.
	browser open.
	"browserfenster := (World submorphs select: [:each | each model = browser]) at: 1."
	browserfenster := browser dependents at: 1.
	browserbereiche := (((browserfenster paneMorphs at: 2) submorphs at: 3) submorphs at: 1) submorphs.
	( browserbereiche  at: 5) borderWidth: 3; borderColor: Color red.! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 09:58'!
browserInstanzen
	^Lesson
	title: 'Instanzen und Bezeichner'
	lesson:
'"
ProfStef previous.
ProfStef next.
"

"ACHTUNG: 
Um das Beispiel dieser Lektion auszuprobieren, ffne einen ''Workspace'' (Weltmen) und schreibe oder kopiere die Befehlszeilen hinein  (Alt/Cmd/Strg-c und -v).  Anschlieend musst du erst einmal den Inhalt des Workspaces *speichern*: Alt/Cmd/Strg-s oder Rechtsklick im Workspace und ''accept (s)''. Dadurch verschwindet auch die orange Ecke rechts oben. 
Jetzt erst ''do-it''!! (Das geht dann auch mit einzelnen Zeilen und neuen Nachrichten, die du an meinEllipse sendest.)"

"Leider haben die beiden Ellipsen aus der vorigen Lektion keine *Namen* oder *Bezeichner*. Daher ist es auch schwierig, ihnen nachtrglich noch weitere Nachrichten zu senden, um sie zu verndern oder zu lschen. Ein Name lsst sich einem neu erzeugten Objekt aber ganz einfach durch eine ''Wertzuweisung'' zuweisen, indem du z.B. statt der ersten Beispielzeile folgendes schreibst:"

| meineEllipse |							"Deklaration einer temporren (Hilfs-)Variablen"
meineEllipse := EllipseMorph new.  		"Erzeugen eines EllipseMorph und Zuweisung eines Namens"
meineEllipse borderWidth:10; borderColor: Color green. 	"Verndern zweier Attributwerte"
meineEllipse openInWorld. 				"Jetzt erscheint die Ellipse links oben am Bildschirm"

"Beachte, dass die Namen von (lokalen) Variablen, also z.B. die Bezeichner von Instanzen wie hier ''meineEllipse'' immer mit einem KLEINBuchstaben beginnen mssen!!"
 
"Du kannst meineEllipse vom Workspace aus auch noch mit folgenden Nachrichten verndern (Beachte die Dezimal*punkte*):"

meineEllipse extent: 50@100.
meineEllipse color: (Color r: 0.7 g: 0.1 b: 0.8).
meineEllipse position: 200@150.

"oder lschen:"

meineEllipse delete.

"Klicke im Browser jetzt wieder auf ''instance''. und gehe zur nchsten Lektion."

ProfStef previous.
ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 09:58'!
browserKategorien
	^Lesson
	title: 'Browser - Kategorien'
	lesson:
'ProfStef previous.
ProfStef next.

"ffne einen Browser mit hervorgehobener Kategorienliste:"

ObjekteKlassenTutorial zeigeKategorienInBrowser: EllipseMorph.

"Die erste Spalte zeigt die ''Kategorien''. Kategorien sind so etwas wie Programmpakete oder Projekte, in denen verschiedene Klassen zusammengefasst sind. So wird es z.B. einfacher, die von dir selbst programmierten Klassen zu finden und auch als solche zu erkennen. Vor allem aber kannst du dann deinen eigenen Programmtext ganz einfach als ''Monticello-Paket'' aus dem Image exportieren."

"Es ist gute Praxis, die Namen deiner Kategorien mit deinen Initialen beginnen zu lassen. Dein erstes Projekt soll eine Pong-Variante sein. Jetzt ist ein guter Moment, dafr die passende Kategorie anzulegen: "

"Klicke mit der rechten Maustaste in die Kategorienspalte und whle im Kontext-Men ''add category...''"

"Wenn du etwa ''Lieschen Mller'' heit, solltest du als Kategoriename ''LM-Pong'' eingeben (ohne Anfhrungszeichen). Du wirst deine Kategorie immer ziemlich am Ende der Kategorienliste finden."

"Ach ja, speichern: Klicke in den pharo-Hintergrund -> save. Kann nicht schaden..."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 09:59'!
browserKlassen1
	^Lesson
	title: 'Browser - Klassen - Kommentar'
	lesson:
'ProfStef previous.
ProfStef next.

"ffne einen Browser mit hervorgehobener Klassenliste:"

ObjekteKlassenTutorial zeigeKlassenInBrowser: EllipseMorph.

"Was siehst du?"

"Unterhalb der Klassenliste befinden sich drei Knpfe:
	- instance
	- ?
	- class"

"Klicke das ''?'' an."

"Im unteren Bereich erscheint nun ein Klassenkommentar, in dem zum einen erklrt wird, was ein ''EllipseMorph'' sein soll (generell sind in Smalltalk ''Morphe'' grafische Objekte, die auf dem Bildschirm erscheinen knnen), zum anderen mit zwei Zeilen Beispielcode gezeigt wird, wie man mit dieser Klasse umgeht. Fhre sie doch einfach aus:"

EllipseMorph new borderWidth:10; borderColor: Color green; openInWorld.
EllipseMorph new borderStyle:(SimpleBorder width: 5 color: Color blue); openInWorld.

"Du kannst die beiden Ellipsen einfach mit dem Mauszeiger packen und verschieben. Wenn du sie bei gedrckter Umschalttaste mit der mittleren Maustaste anklickst, erscheint auch das Halo, das du von Etoys her kennst. So kannst du sie auch wieder loswerden."

"Sieh dir die beiden Befehlszeilen genauer an. Was passiert da der Reihe nach?"

"Erst wird mit" EllipseMorph new . "eine neue Ellipse, also eine ''Instanz'' der Klasse EllipseMorph erzeugt. ''new'' ist dabei eine Nachricht an die *Klasse* EllipseMorph."

"Anschlieend erhlt diese *Instanz*, also das neu erzeugte *Objekt* in Befehlskaskaden (erinnerst du dich an die Strichpunkte?) die Nachrichten ''borderWidth:'', ''borderColor:'', ''borderStyle:'' und ''openInWorld'', wobei letztere dafr sorgt, dass die Ellipse am Bildschirm erscheint. Dabei werden auch noch je eine Instanz der Klassen ''Color'' und ''SimpleBorder'' erzeugt."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 09:59'!
browserKlassen2
	^Lesson
	title: 'Browser - Klassen - instance - Klassenhierarchie'
	lesson:
'ProfStef previous.
ProfStef next.

"ffne ggf. erneut einen Browser mit hervorgehobener Klassenliste"

ObjekteKlassenTutorial zeigeKlassenInBrowser: EllipseMorph.

"und klicke auf ''instance'' unterhalb der Klassenliste."

"Was steht jetzt unten im Definitionsbereich? Wichtig sind frs erste folgende drei Eintrge:"

BorderedMorph subclass: #EllipseMorph

"EllipseMorph ist also eine Unterklasse von BorderedMorph. Beachte das ''#'' vor dem Klassennamen. (Der Klassenname wird so als *Symbol* eindeutig erzeugt.)"

"Einen berblick ber alle Oberklassen von EllipseMorph erhltst du, indem du im Browser auf das bunte rechteckige Symbol vor dem Klassennamen oder auf den ''hierarchy''-Knopf klickst, oder mit"

EllipseMorph browseHierarchy

"Dann ffnet sich ein Hierarchie-Browser. Ihm fehlt die Kategorienliste, dafr sind in der Klassenliste die Ober- und Unterklassen in ihrer Hierarchie aufgelistet."

	instanceVariableNames:  ''''

"Hier stehen zwischen einfachen Anfhrungszeichen die Instanzvariablen, also die Attribute von Instanzen der Klasse."

"Hat ein EllipseMorph wirklich keine Attribute? Im Klassenkommentar war doch die Rede von ''borderWidth'' und ''borderColor''?!!? Wo stehen die dann?"

"Wechsle noch einmal zum Hierarchie-Browser fr EllipseMorph und schau dir die Oberklassen an - gefunden? Wie viele Attribute hat ein EllipseMorph insgesamt? Wie heien sie?"

	category: ''Morphic-Basic''

"Die Klasse EllipseMorph ist der Kategorie ''Morphic-Basic'' zugeordnet, gehrt also zu den einfachen grafischen Objekten, die man immer wieder bentigt. Welche anderen Morphe sind das?"
 
"Solltest du einmal eine Klasse in eine andere Kategorie einordnen wollen, kannst du entweder diesen Eintrag ndern, oder sie einfach mit dem Mauszeiger im Browser in die andere Kategorie ziehen. Das gilt spter auch fr das Umordnen von Methoden und Protokollen."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 09:59'!
browserKlassen3
	^Lesson
	title: 'Browser - Klassen - class'
	lesson:
'ProfStef previous.
ProfStef next.

"ffne ggf. erneut einen Browser mit hervorgehobener Klassenliste"

ObjekteKlassenTutorial zeigeKlassenInBrowser: EllipseMorph.

"Wenn du unterhalb der Klassenliste auf ''class'' klickst, erhltst du Zugriff auf die Methoden, die man - etwa bei der Instanzerzeugung - direkt an die Klasse schicken kann."

"Das ist fr dich nur bei wenigen Klassen interessant. Bei EllipseMorph siehst du da z.B. gar nichts, dafr aber bei Color oder Character. Dort findest du etwa die Definitionen fr benannte Farben wie" Color blue. "oder Sonderzeichen wie" Character tab.

"Sieh dich etwas um:"

Color browse.
Character browse.

"Jetzt wird es aber Zeit, dass du endlich deine ersten eigenen Klassen anlegst!!"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/14/2011 22:31'!
browserMethoden
	^Lesson
	title: 'Browser - Methoden - Rckgabewert'
	lesson:
'ProfStef previous.
ProfStef next.

"Der Bauplan jeder Methode in Smalltalk:"

	messageSelectorAndArgumentNames
		"comment stating purpose of message"

		| temporary variable names |
		statements
.
"	- In der ersten Zeile steht der Name der Methode und ggf. die Namen der Parameter. 
	  Methodennamen beginnen immer mit einem KLEINbuchstaben!!
	- Als zweites kommt in doppelten Anfhrungszeichen ein Kommentar, 
	  der die Funktion der Methode erklrt.
	- Bei Bedarf werden dann zwischen zwei senkrechten Stichen die Namen von 
	  Hilfsvariablen deklariert,
	- Anschlieend folgen die eigentlich auszufhrenden Befehle."

"ffne einen Browser mit hervorgehobener Methodenliste:"

ObjekteKlassenTutorial zeigeMethodenInBrowser: EllipseMorph mitMethode: ''defaultColor''.

"Sieh dir die Methodendefinition an:"

	defaultColor
		"answer the default color/fill style for the receiver"     .
		^ Color yellow
.
"Der Kommentar erklrt, was die Methode leistet: Sie gibt die Standardfllung des Morphs als Ergebniswert zurck. In diesem Fall ist das eine Instanz der Farbe Gelb."

"Entscheidend ist hier der *Rckgabeoperator* ''^'' in der letzten Zeile. (Manchmal wird er auch als Pfeil nach oben dargestellt, auf der Tastatur ist es aber immer das Dach-Symbol.) Er entspricht der ''return''-Anweisung in anderen Programmiersprachen und besagt folgendes:

	Liefere den Wert der aktuellen Zeile als Ergebnis an den Sender der Nachricht 
	und beende die Methode.
	Nachfolgende Befehlszeilen werden nicht mehr ausgefhrt!!"
	
"Da dein PongBall eine Unterklasse von EllipseMorph ist, erbt er diese Methode und ist deshalb auch von Haus aus gelb. Ellipsen sollen von Haus aus gelb bleiben, deine Pongblle aber nicht. ndere das daher folgendermaen, indem du die Methode *berschreibst*:

	- ffne einen Browser fr deine PongBall-Klasse.
	- Whle in der Protokollliste ''-- all --'' aus.
	- Ersetze im Definitionsbereich die Methodenvorlage 
	  durch obigen Text von EllipseMorph>>defaultColor.
	- Speichere ihn schon einmal mit Alt/Cmd/Strg-s.
	- Solltest du aufgefordert werden, deinen Namen einzugeben, 
	  schreib ihn in der Form VornameNachname (zusammengeschrieben).
	- In der Protokollliste erscheint jetzt ein ''as yet unclassified'',
	  weil die Methode noch zu keinem Protokoll gehrt.
	- Rechtsklick auf die Protokollliste:
	- ''categorize automatically''
	- Weil es sich bei ''defaultColor'' um eine Standardmethode handelt,
	  wird sie automatisch in das Protokoll ''defaults'' einsortiert.
	
	- ffne einen Browser fr die Klasse ''Color'':" Color browse. " 
	- Klicke unterhalb der Klassenliste auf ''class''.
	- Whle das Protokoll ''named colors''.
	- Suche dir in der Methodenliste statt ''yellow'' einen anderen Farbnamen aus.
	- Fge ihn statt ''yellow'' in die ''defaultColor''-Methode deines PongBalls ein und speichere."

"Probier''s aus und erzeuge hier oder in einem Workspace eine Instanz *deiner* PongBall-Klasse:"

MSPongBall new openInHand.

"Passt das soweit?"

"Weit du noch, wie du das Halo bekommst oder dem Ball im Workspace erst einen Namen zuweist, um ihn wieder lschen zu knnen? 
Du hast das hier schon einmal gesehen:"

ProfStef tutorial: ObjekteKlassenTutorial lesson: #browserKlassen1. 

"Probier das noch einmal aus und sorge dann dafr, dass auch der Schlger von Haus aus eine passende Farbe bekommt."

"Wenn du in der Protokollliste ''-- all --'' auswhlst, siehst du in der Methodenliste smtliche Methoden, die in der Klasse definiert, man sagt auch, *implementiert* sind. Was ist in der Liste bei der Methode ''defaultColor'' anders als bei den Accessoren?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 09:59'!
browserMethodenUeberschreiben
	^Lesson
	title: 'Methoden berschreiben - Implementoren'
	lesson:
'ProfStef previous.
ProfStef next.

"ffne ggf. einen Browser mit hervorgehobener Methodenliste. EllipseMorph kannst du gerne auch durch deine PongBall-Klasse ersetzen:"

ObjekteKlassenTutorial zeigeMethodenInBrowser: EllipseMorph mitMethode: ''defaultColor''.

"Vor ''defaultColor'' erscheint ein grnes Pfeilsymbol. Wenn du das anklickst (tu das!!), wirst du gebeten, aus einer Liste einen ''Implementor'' auszuwhlen. In der Liste stehen die Ober-/Unterklassen der aktuellen Klasse, in denen eine Methode gleichen Namens definiert oder ''implementiert'' ist. Man sagt, diese Methoden werden hier ''berschrieben'' oder ''berladen''."

"Whle die verschiedenen Implementierungen aus. Welche Farbe hat ein Morph normalerweise?"

"TIPP: Rechter Mausklick oder Alt/Cmd/Strg-f in der Kategorienliste bietet ein Suchfeld fr Klassennamen."

"Ab jetzt wechsest du bei deinen Klassen am besten in die Hierarchie-Ansicht im Browser (''hierarchy''-Knopf), dann kannst du bequem durch die Oberklassen wandern."

"Noch ist dein Ball nicht kreisfrmig, auch der Schlger hat vermutlich noch die falsche Form. Auch knntest du bei beiden noch Randfarbe und -strke anpassen. All diese Eigenschaften werden ber Standardmethoden wie ''defaultColor'' gesteuert. Durchsuche daher die Oberklassen deiner beiden Klassen nach entsprechenden ''defaultXYZ''-Methoden und berschreibe sie ananlog zu ''defaultColor''. Am besten whlst du dabei gleich vor dem Schreiben das Protokoll ''defaults''. Ansonsten kannst du die neuen Methoden auch mit dem Mauszeiger in das Protokoll ziehen oder ''categorize automatically''."

"Erzeuge zur Kontrolle auch Instanzen. Du kannst dich auch an der Beispielskizze orientieren:"

ObjekteKlassenTutorial zeigePongSkizze.

"Wenn du das geschafft hast, gehe zur nchsten Lektion:"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 09:58'!
browserProtokolle
	^Lesson
	title: 'Browser - Protokolle'
	lesson:
'ProfStef previous.
ProfStef next.

"Wenn du Accessoren erzeugst, erscheint in der dritten Spalte des Browsers ''accessing''. Das nennt man in Smalltalk das *Protokoll*, zu dem die Get- und Set-Methoden gehren."

"ffne einen Browser mit hervorgehobener Protokollliste:"

ObjekteKlassenTutorial zeigeProtokolleInBrowser: EllipseMorph mitProtokoll: ''geometry''.

"Du siehst hier einige bliche Protokolle:
	- accessing
	- geometry
	- initialization
	- testing
Ebenso wie die Kategorieren fr die Klassen sind Protokolle einfach nur logische Gruppierungen von Methoden, um besser die bersicht zu behalten."

"''accessing'' kennst du bereits, was mit ''geometry'' gemeint ist, kannst du dir vermutlich denken. In ''initialization'' sind alle Methoden versammelt, die mit der Erzeugung von Instanzen zu tun haben - sprich alles, was in Folge der Nachricht ''new'' passiert. ''testing'' beinhaltet gewhnlich Nachrichten, auf die ein Objekt mit ''Ja'' oder ''Nein'' antwortet - etwa ''Reagierst du auf Tastatureingaben?''"

"Du kannst bei deinen eigenen Klassen auch Protokolle hinzuzfgen oder verndern. ffne dazu z.B. einen Browser fr deine PongBall-Klasse:"

MSPongBall browse.

"TIPP: Rechtsklick auf die Kategorienliste im Browser bietet ein ''find class...(f)'' (Geht also auch mit Alt/Cmd/Strg-f). Da kannst du dann den Namen (oder Teile davon) der Klasse eingeben, die du suchst."

"Rechtsklick auf die Protokollliste liefert ein Kontextmen, in dem vor allem die ersten beiden Eintrge interessant sind:
	- ''add category''
	- ''categorize automatically''
Ersteres ist klar, denke ich - ''category'' meint hier ''Protokoll''. Letzteres fhrt dazu, dass alle bereits vorhandenen Methoden automatisch in irgendwelche Protokolle einsortiert werden. Bei den Accessoren ist das z.B. passiert."

"Fge jeder deiner drei Klassen das Protokoll ''spielsteuerung''  und deiner PongBall-Klasse zustzlich das Protokoll ''physik'' hinzu. (blicherweise beginnen Protokollnamen mit einem Kleinbuchstaben.)"

"Speichere dein pharo-image wieder einmal!!"

"Whle nun irgendein Protokoll in der Liste aus. Was siehst du dann unten im Definitionsbereich des Browsers?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 09:59'!
browserSenderImplementoren
	^Lesson
	title: 'Sender und Implementoren von Nachrichten'
	lesson:
'ProfStef previous.
ProfStef next.

"Damit z.B. die Methode MSPongBall>>defaultMasse ausgefhrt wird, muss der Instanz diese Nachricht erst einmal gesendet werden. Wann/wie/wo passiert das?"

"ffne einen Browser fr deine PongBall-Klasse (Name anpassen!!) und die Methode defaultMasse:"
OBSystemBrowser openOnClass: MSPongBall selector: #defaultMasse.

"In der Knopfleiste gibt es einen Knopf ''senders''. Wenn du mit dem Mauszeiger etwas darber bleibst, erscheint auch ein Hilfetext. ''Sender'' sind alle Methoden, in denen diese Nachricht gesendet, also die aktuelle Methode aufgerufen wird. Klicke darauf!!"

"Was siehst du? berrascht?"

"Wiederhole das gleiche fr die Methode defaultColor:"
OBSystemBrowser openOnClass: MSPongBall selector: #defaultColor.

"Was siehst du jetzt? Interessant sind nur Methoden von Oberklassen deiner Klasse, hier also von Morph. Sieh dir die Methoden an!!"

"Entscheidend ist die Methode ''initialize'', man nennt sie auch den *Konstruktor* der Klasse. "

"ffne Morph>>initialize im Browser:"
OBSystemBrowser openOnClass: Morph selector: #initialize.

"Sieh dir die Methodendefinition genau an. Was passiert da alles?"

"In der Knopfleiste des Browsers gibt es auch einen Knopf ''implementors''. Damit erhltst du eine Liste aller Klassen, in denen die aktuelle Methode ebenfalls definiert, also *implementiert* ist. Sieh dir ein paar davon an, indem du sie in der linken Spalte auswhlst. Unten wird dann die Definition gezeigt. Was ist allen Definitionen von ''intialize'' gemeinsam?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:00'!
browserUeberblick
	^Lesson
	title: 'Browser - berblick'
	lesson:
'ProfStef previous.
ProfStef next.

"Der Browser ist das zentrale Werkzeug beim Programmieren. Mit ihm verwaltest du alle Klassen und den zugehrigen Quelltext.

Es gibt verschiedene Mglichkeiten, einen Systembrowser zu ffnen:"

"- Klick in den Hintergrund, dann ''System Browser'' im Weltmen whlen."
"- Markieren eines Klassennamens, Rechtsklick und dann ''Alt/Cmd/Strg-b'' (fr ''browse''). Probier''s aus:"

EllipseMorph 

"- Senden der entsprechenden Nachricht an eine Klasse:"

EllipseMorph browse.

"Der Browser besitzt oben eine Suchzeile, mit der du z.B. nach Klassen oder Methoden suchen kannst, darunter vier Spalten mit Listen, eine Knopfleiste und zuunterst den Definitionsbereich, in dem du Programmtext oder Kommentare lesen und bearbeiten kannst."

"Als nchstes die vier Listenspalten im einzelnen (Fhre die Befehlszeilen jeweils aus ''do-it''):"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/14/2011 22:23'!
defaultMethoden
	^Lesson
	title: 'Standardwerte - default-Methoden'
	lesson:
'ProfStef previous.
ProfStef next.

"Dein PongBall und PongSchlaeger haben noch weitere Attribute. Wie du z.B. beim Tausammlerprojekt unter Etoys gelernt hast, brauchen all diese Attribute sinnvolle Startwerte. Es bewhrt sich, dafr jeweils eigene default-Methoden anzulegen, die diese Standardwerte zurckgeben. Konkret brauchst du folgende Methoden:

PongBall>>defaultMasse
PongBall>>defaultGeschwindigkeit
PongBall>>defaultBeschleunigung
PongBall>>defaultDeltaT

PongSchlaeger>>defaultPunkte
PongSchlaeger>>defaultFehler

Sinnvolle Standardwerte knnten folgende sein:

	- Masse: 			1
	- Geschwindigkeit: 	0@0
	- Beschleunigung: 	0@0
	- deltaT: 			0.01

	- Punkte: 			0
	- Fehler: 			0

Lege all diese default-Methoden an (mit sinnvollen Kommentaren!!) und speichere dann wieder einmal dein pharo-Image."

"TIPP: Am wenigsten Arbeit hast du, wenn du im Browser jeweils deine defaultColor-Methode auswhlst, sie im Definitionsbereich anpasst (den Namen ''defaultColor'' in ''defaultMasse'' nderst, im Kommentar ein, zwei Wrter ersetzt und den richtigen Rckgabewert eintrgst) und sie dann mit Alt/Cmd/Strg-s abspeicherst. Dann ist die neue Methode auch automatisch im gleichen Protokoll."

"TIPP: Rot gefrbter Text im Definitionsbereich des Browsers bedeutet, dass du einen Syntaxfehler in deinem Programmtext hast. Gern sind das vergessene Punkte oder Anfhrungszeichen, aber auch Tippfehler in Methodenaufrufen."

"HINWEIS: Ausdrcke wie ''5@3'' sind in Smalltalk Instanzen der Klasse ''Point'', also zweidimensionale Koordinaten, mit denen man auch rechnen kann:"
(5@3) inspect.
"Whle die folgenden Zeilen jeweils aus, dann Rechtsklick und ''print it (p)'' oder Alt/Cmd/Strg-p. Das Ergebnis lschst du dann am besten gleich wieder, wenn die nachfolgenden Zeilen recht rot  werden."

(5@3) + (2@ -1).
5@3 * 2.
(5@3) * 2.
2* 5@3.
2 * (5@3).

(5@3) x.
(5@3) y.
(5@3) r.  "Pythagoras?"

"Wenn du fertig bist, erzeuge je eine Instanz deiner beiden Klassen und ffne einen Inspektor (Klassennamen anpassen!!):"

MSPongBall new inspect.
MSPongSchlaeger new inspect.

"Passen die Attribute und ihre Werte (alles in der linken Spalte zu sehen)?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:00'!
erzeugeAccessoren
	^Lesson
	title: 'Zugriff auf Instanzvariablen - Accessoren (Get/Set)'
	lesson:
'ProfStef previous.
ProfStef next.

"Im Sinne der Datenkapselung sind Attribute privat, also nur ber (ffentliche) Methoden ansprechbar. Du hast solche Methoden schon aufgerufen, um etwa die Farbe oder Gre eines Objektes zu verndern."

"Diese Methoden, die *Accessoren*, kannst du in pharo fr jede deiner Klassen am einfachsten folgendermaen erzeugen: 

	- Whle im Browser in der Klassenliste die Klasse aus, also etwa MSPongBall.
	- Rechtsklick auf der Klassenliste liefert ein Kontextmen
	- Whle dort
		- ''refactor class'', wenn du fr alle Variablen auf einmal,
		- ''refactor instance variable'', wenn du nur fr ein bestimmtes Attribut Get- und Set-Methode erzeugen willst.
	- Whle ''accessors'' und im sich dann ffnenden Fenster ''accept''."
	
"Mach das fr all deine Klassen. "

"Es werden fr jede Variable zwei Methoden erzeugt:

- eine Get-Methode, die genauso heit wie die Variable, also etwa ''MSPongSchlaeger>>punkte'': Damit kannst du den aktuellen Wert der Instanzvariable auslesen.

- eine Set-Methode, die am Ende des Namens noch einen Doppelpunkt hat, also etwa ''MSPongSchlaeger>>punkte:'': Damit kannst du den Wert der Instanzvariable verndern."

"Du kannst beide Methoden auch ausprobieren. Erzeuge dazu eine Instanz etwa deines PongSchlaegers (Klassenname anpassen!!) und ffne einen Inspektor:"
MSPongSchlaeger new inspect.

"Um den aktuellen Wert des Attributs ''punkte'' auszulesen, gibst du im Inspektor in der Eingabezeile rechts unten"
self punkte.
"ein und dann Rechtsklick und ''print it (p)'' oder Alt/Cmd/Strg-p, um den Wert anzeigen zu lassen."

"Um den Wert der punkte zu verndern, gibst du z.B."
self punkte: 2.
"ein und dann Rechtsklick und ''do it (d)'' oder Alt/Cmd/Strg-d, um den Befehl auszufhren."

"Was hat sich durch das Erzeugen der Accessoren alles im Browser verndert?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:00'!
erzeugeAttribute
	^Lesson
	title: 'Attribute und Instanzvariablen'
	lesson:
'ProfStef previous.
ProfStef next.

"Was mssen die Objekte in deinem Pong wissen? Was muss man sie fragen knnen? Welche Eigenschaften mssen sich verndern knnen? Kurz: Welche Attribute - in Smalltalk *Instanzvariablen* -  sind ntig?"

"Beginnen wir mit dem Ball: Von der Physik her muss er 
	- seine Position, 
	- Geschwindigkeit, 
	- Beschleunigung und 
	- seine Masse kennen. 
Da seine Bewegung mit Hilfe der Methode kleiner Schritte simuliert werden soll, muss er auch 
	- den Zeitschritt ''dt'' 
der Simulation kennen. 

Wenn du im Browser in der Klassenliste deine PongBall-Klasse auswhlst und in der Knopfleiste unterhalb ''variables'' anklickst, erhltst du eine Auflistung aller Instanzvariablen, die ein PongBall bereits besitzt, weil er ja ein EllipseMorph ist. Whle in der Liste z.B. ''bounds'' aus, dann wird rechts angezeigt, welche Methoden dieses Attribut benutzen und in welcher Oberklasse sie definiert sind. Du siehst dort z.B. ''Morph>>position'' (Die Methode ''position'' ist also in der Oberklasse ''Morph'' definiert.). Wenn du das anklickst, kannst du im unteren Feld lesen, dass mit der Position eines Morphes gewhnlich seine linke obere Ecke gemeint ist."

"Fazit ist jedenfalls, dass jeder Morph seine Position kennt (an sich nicht berraschend, oder?). Also musst du in der Klassendefinition nur die anderen Instanzvariablen eintragen (dann wieder Alt/Cmd/Strg-s !!):"

EllipseMorph subclass: #MSPongBall
	instanceVariableNames: ''v a m dt''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"hnlich sieht es fr den Schlger aus. Neben seiner Position muss er wissen, wie viele Punkte bzw. Fehler er gemacht hat:"

RectangleMorph subclass: #MSPongSchlaeger
	instanceVariableNames: ''punkte fehler''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"Und was muss das ganze Spiel wissen/kennen? Es stellt unter anderem die Verbindung zwischen allen beteiligten Objekten her. Daher sollte es das Spielfeld sowie alle Figuren kennen. Auerdem kann es gnstig sein, wenn es wei, ob es gerade luft oder angehalten ist:"

Object subclass: #MSPong
	instanceVariableNames: ''spielfeld figuren laufend''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"So, und wie greift man nun auf diese Instanzvariablen zu? Wie liest man ihre Werte aus oder verndert sie - wenn sich etwa der Schlger einen Punkt verdient hat? Schlielich sind Attribute grundstzlich privat."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:00'!
erzeugeUnterklassen
	^Lesson
	title: '(Unter-)Klassen anlegen'
	lesson:
'ProfStef previous.
ProfStef next.

"ffne einen Browser z.B. mit" OBSystemBrowser open. "und whle in der Kategorienliste deine Pong-Kategorie aus, die du in" 
ProfStef tutorial: ObjekteKlassenTutorial lesson: #browserKategorien. 
"angelegt hast. Bei mir heit sie ''MS-Pong'' - Warum habe ich damals diesen Namen gewhlt? Klar?"

"Noch ist diese Kategorie leer - keine Klassen vorhanden. Aber unten im Definitionsbereich des Browsers steht bereits diese Vorlage zum Erzeugen einer neuen Klasse:"

Object subclass: #NameOfSubclass
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"Welche Klassen bentigst du fr deine Pong-Variante? Sieh in deinem UML-Diagramm nach!!"

"Vermutlich folgendes: Ball, Schlger, Textfeld, Schaltknopf, Spielfeld - und das ganze Spiel natrlich. Nicht alles musst du neu erfinden, Textfelder, Schaltknpfe und Spielfelder gibt es in pharo bereits:"

TextMorph browse.
SimpleButtonMorph browse.
PasteUpMorph browse.

"Bleiben MSPong, MSPongBall und MSPongSchlaeger. Beachte, dass Klassennamen immer mit einem GRObuchstaben beginnen mssen!! Vorsichtshalber setze ich auch meine Initialen vor die Klassennamen - nicht dass es Klassen mit diesen Namen bereits gibt."

"Zum Anlegen dieser neuen Klassen musst du nur obige Vorlage im Browser anpassen (also den Klassennamen ndern - achte darauf, dass das ''#'' stehen bleibt!!) und die vernderte Vorlage *speichern* (Alt/Cmd/Strg-s oder Rechtsklick und ''accept (s)'' im Kontextmen), also etwa:"

Object subclass: #MSPong
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"MSPong ist etwas vllig neues, lege es daher direkt als Unterklasse von ''Object'' an, wie gezeigt!! "

"MSPongBall soll im Grunde eine Ellipse mit zustzlichen Attributen und Methoden sein, MSPongSchlaeger ein Rechteck. (Ergnze das ggf. in deinem UML-Diagramm!!) Beides gibt es bereits. Daher kannst du diese Klassen als *Unterklassen* von EllipseMorph bzw. RectangleMorph anlegen:"

EllipseMorph subclass: #MSPongBall
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
RectangleMorph subclass: #MSPongSchlaeger
	instanceVariableNames: ''''
	classVariableNames: ''''
	poolDictionaries: ''''
	category: ''MS-Pong''
.
"Fehlt frs erste noch eines - weniger fr den Rechner als vielmehr fr dich selber und alle, die dein Projekt einmal benutzen oder weiterentwickeln wollen. Was wohl?"

"berlege kurz - du erfhrst es in der nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:00'!
fazitKlassenAnlegen
	^Lesson
	title: 'Fazit: Klassen anlegen'
	lesson:
'ProfStef previous.
ProfStef next.

"Glckwunsch!! Du hast jetzt schon ganz schn etwas geschafft!!"

"Hier zum merken noch einmal zusammengefasst das wichtigste zum Anlegen neuer Klassen:

0. Plane sorgfltig, z.B. mit UML.

1. Lege ggf. eine neue Kategorie mit einem aussagekrftigen Namen fr dein Projekt an (''add category'' in der Kategorienliste). Der Name sollte mit deinen Initialen beginnen.

2. In den meisten Fllen wirst du deine Klassen direkt als Unterklassen von ''Object'' anlegen. Oft empfiehlt es sich aber, erst einmal im Browser nach hnlichen, bereits existierenden Klassen zu suchen (Alt/Cmd/Strg-f in der Kategorienliste)

3. Gib deiner Klasse einen aussagekrftigen Namen (Grobuchstabe am Anfang!!), ebenso den Instanzvariablen (Kleinbuchstabe am Anfang!!).

4. Schreibe einen Klassenkommentar mit einer kurzen Beschreibung und Beispielbefehlen, wie man diese Klasse benutzt.

5. Erzeuge, soweit ntig, Accessoren fr die Instanzvariablen (Rechtsklick auf dem Klassennamen, dann ''refactor class'' oder ''refactor instance variable'' und ''accessors'').

6. Erzeuge defaultXYZ-Methoden mit den Standardwerten der Instanzvariablen. berschreibe dabe ggf. auch Methoden der Oberklassen.

7. berschreibe den Konstruktor (''initialize'') der Oberklasse: Immer zuerst ''super initialize'', dann Wertzuweisungen fr die Instanzvariablen, ggf. Konstruktion aus Bestandteilen (''submorphs'') oder Startmethodenaufruf.

8. Lege sinnvolle Protokolle fr die Methoden an: fr Standardmethoden mit ''categorize automatically'', fr spezielle Dinge mit ''add category'' in der Protokollliste.

9. Bereichere all deine Programmtexte um sinnvolle Kommentare!!

10. Erzeuge testhalber Instanzen deiner Klassen und berprfe sie mit Inspektoren.

11. Speichere ab und an dein pharo-Image."

"Tja, und was machst du, wenn dir im Laufe der Arbeit auffllt, dass du deine Planung verbessern solltest und daher dein Projekt umbauen musst?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:00'!
initializeMethode
	^Lesson
	title: 'Konstruktor - initialize'
	lesson:
'ProfStef previous.
ProfStef next.

"ffne Morph>>initialize im Browser:"
OBSystemBrowser openOnClass: Morph selector: #initialize.

"''initialize'' ist die Methode, die als erste beim Erzeugen eines Objektes mit ''new'' aufgerufen wird:"

Morph>>initialize
	"initialize the state of the receiver"
	super initialize.
	owner := nil.
	submorphs := EmptyArray.
	bounds := self defaultBounds.
	color := self defaultColor
.
"In dieser Methode wird frisch erzeugte Instanz richtig ''konstruiert'', daher heit sie auch *Konstruktor*."

"Insbesondere werden alle Attribute mit *Werten* versehen, hier sind das etwa ''bounds'', also die Abmessungen und ''color''. Falls das Objekt aus mehreren Bestandteilen (hier ''submorphs'') besteht, werden diese neu erzeugt und ggf. richtig zusammengesetzt.. Das kannst du z.B. beim MovingEyeMorph schn sehen:"

MovingEyeMorph new openInHand. 	"Zum Entfernen musst du zwei EllipseMorphe lschen."
OBSystemBrowser openOnClass: MovingEyeMorph selector: #initialize.

"Hier werden neben der weien Farbe zwei EllipseMorphe erzeugt und mit addMorphCentered: ineinandergesetzt."

"Manchmal wird am Ende noch ein Startbefehl aufgerufen, etwa bei WatchMorph>>initialize:"

WatchMorph new openInWorld. 	
OBSystemBrowser openOnClass: WatchMorph selector: #initialize.

"Das wirst du vielleicht fr deine Pong-Klasse brauchen."

"Mit am wichtigsten und allen Konstruktoren gemeinsam ist aber die erste Befehlszeile:"

	super initialize.

"In Smalltalk ist jede Klasse eine *Unterklasse* - und sei es nur von ''Object''. Wenn z.B. ein PongSchlaeger erzeugt werden soll, muss erst einmal alles passieren, was auch schon fr die Erzeugung eines RectangleMorphes und damit erst recht alles, was fr die Erzeugung eines Morphes oder eben eines Objects ntig ist. Das musst du aber nicht jedesmal alles wieder neu schreiben.

Stattdessen wird mit *super* erst einmal die entsprechende Methode der *Oberklasse* aufgerufen. Anschlieend folgen nur noch die speziellen Anpassungen fr die aktuelle Klasse."

"Damit sieht z.B. der Konstruktor fr MSPongSchlaeger so aus:"

MSPongSchlaeger>>initialize
	"initialize the state of the receiver"
	super initialize.							"Konstruktor der Oberklasse"
	punkte := self defaultPunkte. 			"Wertzuweisungen fr Instanzvariablen"
	fehler := self defaultFehler.				"Beachte die Doppelpunkte!!"
			
"Lege die Konstruktoren fr deine PongSchlaeger- und PongBall-Klassen an (whle beim Protokoll erst einmal ''-- all --''), fhre dann wieder ''categorize automatically'' aus und speichere dein pharo-Image."

"Wenn du das erledigt hast, erzeuge Instanzen deiner beiden Klassen und untersuche sie mit Inspektoren. Weit du noch, welche Befehle du dafr brauchst? Passen jetzt die Werte der Attribute?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:01'!
inspektoren
	^Lesson
	title: 'Inspektoren'
	lesson:
'ProfStef previous.
ProfStef next.

"Du kannst bereits Instanzen deiner neuen Klasse erzeugen und mit einem Inspektor untersuchen (ersetze in der folgenden Befehlszeile ''MSPong'' durch den Namen *deiner* Pong-Klasse):"

MSPong new inspect.

"Der Inspektor zeigt die Attribute des Objektes. Nicht gerade viel zu sehen, aber ein MSPong ''wei'' eben noch nicht viel, ist bislang einfach ein Objekt..."

"Sieh dir nun deine Blle und Schlger an (immer mit deinen eigenen Klassennamen!!):"

MSPongBall new openInWorld.
MSPongBall new inspect.
MSPongSchlaeger new openInHand.
MSPongSchlaeger new inspect.

"Hier gibt es schon mehr zu sehen - Geerbtes von den Oberklassen. (Umschalttaste + mittlerer Mausklick liefert das Halo.)"

"Du kannst den Objekten mit dem Inspektor auch Nachrichten schicken: Schreibe in die Eingabezeile rechts unten im Inspektor etwa"

self color: Color red. 

"oder" 

self extent: self extent * 2.

"und dann ''do it (d)''."

"Welche Attribute bentigen deine Klassen noch? Ergnze dein UML-Diagramm ggf. und gehe dann zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/1/2011 19:16'!
intro
	^Lesson
	title: 'Vorwort'
	lesson:
'ProfStef next.

"In diesem Tutorial lernst du am Beispiel einer einfachen Spielprogrammierung typische Vorgehensweisen und den Umgang mit wichtigen Werkzeugen bei der Programmierung in Smalltalk. Ziel wird eine Variante des Klassikers ''Pong'' sein - angereichert um ein klein wenig Physik."

"So noch nicht geschehen, solltest du zunchst das SmalltalkSyntaxTutorial von ProfStef durcharbeiten:"

ProfStef goOn: SmalltalkSyntaxTutorial.

"Einen berblick ber weitere Tutorials erhltst du im ProfStefBrowser:"

ProfStefBrowser go. "oder zu finden im Weltmen (Klick in den Hintergrund) unter Help"

"Der ProfStefBrowser ist auch hilfreich, wenn du in diesem Tutoral navigieren willst. Starte es dann ber das Weltmen oder mit"

ProfStefBrowser goOn: ObjekteKlassenTutorial.

"Auerdem wird vorausgesetzt, dass du Erfahrungen in der Modellierung mit UML hast, wie du sie z.B. beimTausammler-Projekt in Etoys sammeln kannst."

"Weiterfhrende Informationen zu Smalltalk findest du z.B. in den Bchern ''Pharo by Example'' (http://pharobyexample.org) und ''Squeak by Example'' (http://squeakbyexample.org)."

"Jetzt aber los!!"

"Befehlszeilen im Text (in der Regel alles, was nicht grn erscheint) kannst du meist einfach markieren und mit ''do it (Alt/Cmd/Strg-d) ausfhren. So auch die nachfolgende Zeile, um zur erste Lektion zu gelangen. Solltest du einmal nach deinem Namen gefragt werden, gib ihn in der Form MarkusSchlager ein, also Vor- und Nachname zusammengeschrieben, aber jeweils mit einem Grobuchstaben beginnend."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:03'!
kommentiereKlassen
	^Lesson
	title: 'Klassenkommentare'
	lesson:
'ProfStef previous.
ProfStef next.

"*Klassenkommentare*"

"Das ist guter Programmierstil und eine groe Hilfe fr jemanden, der dein Projekt verstehen will, oder auch fr dich selber, wenn du es z.B. einmal weiterentwickeln willst, Fehler suchst oder eine (hnliche) Klasse in einem anderen Projekt bentigst. Gewhne dir daher an, deine Programmtexte *immer* zu kommentieren!!"

"Whle nacheinander deine drei neuen Klassen im Browser aus, klicke auf das ''?'' unterhalb der Klassenliste und schreibe unten im Definitionsbereich eine kurze Beschreibung der jeweiligen Klasse (Speichern mit Alt/Cmd/Strg-s). Zumindest bei der Klasse MSPong sollte auch eine Befehlszeile enthalten sein, mit der man spter das Spiel starten kann, also etwas in dieser Art:"
''
	MSPong - eine Variante des Klassikers Pong fr einen Spieler von Markus Schlager. 
	Start mit

	MSPong new.
''
"(Beachte den Punkt am Ende der Befehlszeile.)"

"Sptestens jetzt ist es an der Zeit, wieder einmal dein pharo-Image zu speichern (Klick in den Hintergrund -> Save)"

"Gibt es schon Instanzen deiner neuen Klassen? Wie sehen sie aus? Welche Attribute haben sie bereits? Das zu untersuchen gibt es *Inspektoren*."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:03'!
lessonDummy
	^Lesson
	title: '(Unter-)Klassen anlegen'
	lesson:
'ProfStef previous.
ProfStef next.

ProfStef tutorial: ObjekteKlassenTutorial lesson: #browserKategorien.

"TODO"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:03'!
monticelloBrowser
	^Lesson
	title: 'Import und Export von Quelltext - Monticello'
	lesson:
'ProfStef previous.
ProfStef next.

"Das derzeit bliche Verfahren, Programmpakete aus dem Image heraus abzuspeichern oder in ein Image zu laden, sind *Monticello-Pakete* (Dateiendung ''.mcz''). Diese werden mit dem *Monticello-Browser* verwaltet. Du hast ihn schon einmal gesehen:"

MCWorkingCopyBrowser  open.

"oder Klick in den pharo-Hintergrund und du findest ihn im Weltmen. ffne ihn jetzt!!

Du siehst zwei Spalten:
	- links eine Liste mit Programmpaketen
	- rechts eine Liste mit ''repositories'', also Speicherorten

Wenn du den Inhalt eines Programmpaketes sehen willst, musst du es nur auswhlen und dann in der Knopfleiste ''Browse'' anklicken. Dann ffnet sich ein Browser hnlich dem SystemBrowser.

Wenn du ein Paket in dein Image laden willst, musst du zustzlich in der rechten Liste ein Repository auswhlen und ''Open'' anklicken. Es erscheint dann ein Fenster, in dem du rechts eine Version des Paketes auswhlen kannst. Im unteren Bereich erscheint dann Anmerkungen zum Paket. Mit ''Load'' kannst du die ausgewhlte Version dann in dein Image laden. Willst du sie dauerhaft behalten, musst du das pharo-Image speichern. 

Willst du ein Paket wieder aus deinem Image entfernen, geht das per Rechtsklick auf dem Paket im Monticello-Browser, dann ''unload package''.

Du willst jetzt *dein Projekt* zum ersten Mal aus dem Image exportieren. 

Dazu musst du erst einmal ein neues Paket fr dein Projekt erzeugen: Klicke dazu auf ''+Package''.

VORSICHT: Du wirst nun nach einem Namen fr dein Paket gefragt. Der *muss* genau so lauten wie der Name der *Kategorie*, die du fr deine Klassen gewhlt hast - oder wie der Anfang des Kategoriennamens. Dann wird automatisch alles in das Paket mit aufgenommen, was sich in Kategorien (oder auch Protokollen) befindet, deren Name mit dem Paketnamen beginnt.

Mein Paket heit daher natrlich MS-Pong.

Wenn du also all deine eigenen Kategorien mit deinen Initialen beginnst, kannst du so auch ganz einfach deine *gesamte* eigene Arbeit auf einmal in ein einziges Paket exportieren. 

Whle in der linken Spalte dein Paket aus. (Wenn du schon einmal sehen willst, was alles zu dem Paket gehrt, kannst du es mit ''Browse'' durchsuchen.)

In der rechten Spalte siehst du bei den Repositories zuoberst einen Pfad der Art

	deinHeimatVerzeichnis/Pharo-X.Y-OneClick.app/Contents/Resources/package-cache

Das ist das Standardverzeichnis, in dem pharo Pakete zwischenspeichert. Die anderen evtl. sichtbaren Repositories sind Server-Adressen im Internet, die die Entwickler von pharo nutzen. 

Willst du deine eigenes Projekt an einem anderen Ort als dem Standardverzeichnis speichern oder eines von dort laden, musst du erst einmal ein entsprechendes Repository hinzufgen - meist wohl ein Verzeichnis auf deinem Rechner. Klicke dazu auf den Knopf ''+Repository'' und whle dann ''directory''. Im nchsten Fenster kannst du dann ein bestehendes Verzeichnis auswhlen oder auch ein neues erzeugen. Es erscheint knftig am Ende der Repository-Liste.

Jetzt musst du links dein Paket und rechts das Repository markieren, in dem du dein Paket abspeichern willst. Klicke dann auf den Knopf ''Save''.

Im nchsten Fenster siehst du oben den Namen der Paketdatei (Paketname-DeinName.Versionsnummer). Im unteren Fenster musst du eine ''Log Message'' eingeben, also eine kurze Beschreibung des Paketes und der nderungen gegenber der zuletzt gespeicherten Version. Dann ''accept''. Fertig."


"Als nchstes steht der Konstruktor fr deine Pong-Klasse an. Wenn er aufgerufen wird, soll unter anderem das fertige Pong-Fenster auf dem Bildschirm erscheinen:" 
ObjekteKlassenTutorial zeigePongSkizze.

"Was muss dazu alles erzeugt und aufgerufen werden? Schreibe dir einen Plan (z.B. als Sequenzdiagramm) zusammen und gehe dann weiter."

ProfStef next.'! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:04'!
oeffneWerkzeuge
	^Lesson
	title: 'Werkzeuge ffnen'
	lesson:
'ProfStef previous.
ProfStef next.

"Die typischen Werkzeuge bzw. Fenster, die du beim Programmieren bentigst"

"Fhre die jeweiligen Programmzeilen mit 
 	- Alt-d/Strg-d/Cmd-d oder  
	- Rechtsklick und dann ''Ausfhren / do it (d)'' 
aus oder klicke auf den Hintergrund und ffne die Werkzeuge dann im Men."

"Falls dieses Tutorial verdeckt wird, findest du es immer in der Fensterliste unten am Rand."

"ein Shout-Workspace - ein Fenster mit Syntaxfrbung und -vervollstndigung, in dem du beliebigen Programmtext eingeben und ausfhren kannst"
SHWorkspace open.

"ein SystemBrowser zur Verwaltung der Klassen"
OBSystemBrowser open.

"ein Methodensucher zum Finden von Methoden nach ihrem Namen oder ihrer Funktion (im Weltmen unter ''Tools'' zu finden)"
SelectorBrowser new open.

"ein Transcript - ein Fenster fr Textausgaben, z.B. auch beim Testen deines Programmtextes"
Transcript open.

"ein Monticello-Browser zum Laden und Speichern von Programmpaketen"

MCWorkingCopyBrowser  open.

"So, jetzt schliee erst einmal wieder all die Fenster."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:04'!
planePong
	^Lesson
	title: 'Das erste Projekt - Pong'
	lesson:
'ProfStef previous.
ProfStef next.

"Am Beispiel einer Variante des Computerspielklassikers Pong wirst du im folgenden typische Vorgehensweisen beim Entwickeln in Smalltalk kennenlernen."

ObjekteKlassenTutorial zeigePongSkizze.

"Der Schlger (rotes Rechteck) soll per Tastendruck nach links und rechts bewegt werden. Der Ball soll sich wie unter dem Einfluss der Schwerkraft bewegen. Falls er den Schlger oder den Spielfeldrand trifft, ndert er zufllig seine Bewegungsrichtung etwas. Fr jeden Treffer mit dem Schlger erhlt man einen Punkt. Das Spiel ist zu Ende, wenn der Ball eine vorgegebene Anzahl oft den unteren Spielfeldrand berhrt hat."

"Entwirf nun als erstes ein UML-Klassendiagramm fr so ein Spiel, dann geh zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/12/2011 08:26'!
pongKonstruktor1
	^Lesson
	title: 'Konstruktor des ganzen Spiels - berblick'
	lesson:
'ProfStef previous.
ProfStef next.

ProfStef tutorial: ObjekteKlassenTutorial lesson: #browserKategorien.

"Der Grundaufbau eines Konstruktors ist immer gleich:

	- Konstruktor der Oberklasse aufrufen
	- smtliche Instanzvariablen mit Startwerten belegen 
	  und ggf. die dazu notwendigen Objekte erzeugen
	- ggf. alle abhngigen Objekte in ihren Startzustand versetzen
	- evtl. erste Methoden aufrufen"

"Die ersten Zeilen des Konstruktors kannst du schon schreiben: Methodenname, Kommentar und Aufruf des Konstruktors der Oberklasse. Fge dazu aber erst ein Protokoll ''initialization'' hinzu, in das du dann den Konstruktor einsortierst. Das hast du hier schon einmal gemacht:"
ProfStef tutorial: ObjekteKlassenTutorial lesson: #browserProtokolle.

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/21/2011 21:13'!
pongKonstruktor10Datenkapselung
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Datenkapselung'
	lesson:
'ProfStef previous.
ProfStef next.

"Folgende zwei Dinge lassen sich auf jeden Fall am Konstruktor der letzten Lektion aussetzen:

1. Fr Ball und Schlger steht zweimal fast der gleiche - relativ komplexe - Befehl da. Stell dir vor, wie der Konstruktor wchst, wenn dein Spiel nach und nach weitere Figuren enthalten sollte. Erkennst du das Problem?

2. Die Pong-Klasse muss zu viel ber Ball und Schlger wissen. Falls sich eine der beiden Klassen verndert, muss das auch hier in der Pong-Klasse angepasst werden, was fehlertrchtig ist. Diesem Problem bist du z.B. im Tausammlerprojekt schon einmal begegnet - *Datenkapselung*:

Wo Ball und Schlger zu Spielbeginn sind und wie sie da aussehen, ist *deren* Sache, nicht die der Pong-Klasse. Genau wie beim Tausammler bentigen auch hier alle beteiligten Klassen je eine reset- und start-Methode."

"Lege schon einmal in jeder deiner drei Klassen ein Protokoll ''spielsteuerung'' an, in das spter die start- und reset-Methoden einsortiert werden sollen."

"Entwirf Struktogramme fr MSPongBall>>reset und MSPongSchlaeger>>reset. In den reset-Methoden sollen alle Instanzvariablen auf ihre Standardwerte gesetzt werden, die Position auf die Startposition. Gibt es dabei ein Problem?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/22/2011 16:42'!
pongKonstruktor11Reset
	^Lesson
	title: 'Konstruktor des ganzen Spiels - reset-Methoden'
	lesson:
'"
ProfStef previous.
ProfStef next.
"

"Der klassisch- ordentliche Weg fr die Umsetzung wre jetzt folgender:

1. Programmiere MSPongSchlaeger>>reset und MSPongBall>>reset - am besten jeweils mit einer Hilfsmethode ''startPosition''.
2. Passe den Konstruktor von MSPong an."

"In Pharo geht es aber auch ganz bequem umgekehrt. Die Entwicklungsumgebung hilft dir dabei. Also:"

"1. Passe MSPong>>initialize an. Das einzige, was sich hier zu ndern hat, ist der Aufruf der reset-Methoden ganz am Ende."

MSPong>>initialize
	"initialize the state of the receiver"
	| ball schlaeger |
	"Konstruktor der Oberklasse"
	super initialize.					
	"Belegung der Instanzvariablen"
	laufend := false.				
	spielfeld := PasteUpMorph new.
	"Initialisierung des Spielfelds - mit einer Befehlskaskade."
	"Beachte, dass man die Hintergrundfarbe erst setzen kann, nachdem das Fenster geffnet ist."
	spielfeld extent: 600@400; 
			openInWindowLabeled: ''Mein Pong'';
			color: Color black.
	"Erzeugung der Figuren"
	ball := MSPongBall new.
	schlaeger := MSPongSchlaeger new.
	"Darstellung der Figuren auf dem Spielfeld"
	ball openInWorld: self spielfeld.
	schlaeger openInWorld: self spielfeld. 
	"Figuren in die Startposition"
	ball reset.
	schlaeger reset.

"Beim Speichern ffnet sich mglicherweise ein Fenster mit dem Titel" 

	''Unknown selector, please confirm, correct or cancel''. 

"Dort musst du den Methodennamen ''reset'' ggf. besttigen. Noch kennt keine deiner Klassen die Methode ''reset''."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/1/2011 15:38'!
pongKonstruktor12MessageNotUnderstood
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Debugger'
	lesson:
'ProfStef previous.
ProfStef next.

"Probier aus, inwieweit das so schon funktioniert, indem du eine neue Instanz deines Spiels erzeugst:"
MSPong new.
"Lass sich dabei ffnende Fenster ggf. geffnet und lies erst hier weiter:"

"Vermutlich hat sich hier neben deinem Pong-Fenster auch ein Fenster mit einem Titel der Art"

	 ''MessageNotUnderstood: MSPongBall>>reset''
. 
"geffnet. Was sich hier meldet, ist der *Debugger* - ein Werkzeug zum Finden und Beheben von Fehlern - ''bugs''."

"Debugger-Fenster sind immer von unten nach oben zu lesen. In ihnen steht, was der Reihe nach passiert ist, ehe ein Fehler aufgetreten ist. In der obersten Zeile steht dabei das letzte Ereignis - meist das Problem. Hier:"
''
	MSPongBall(Object)>>doesNotUnderstand: #reset
''.
"Der MSPongBall (eine Unterklasse von Object) kennt keine Methode ''reset''. (Das Doppelkreuz kennzeichnet den Methodennamen als Symbol.) Wenn du genauer wissen willst, was da passiert ist, kannst du die Zeile auch anklicken, aber das wird dir jetzt noch nicht recht helfen."

"Natrlich kennt MSPongBall noch keine reset-Methode - du hast sie schlielich noch gar nicht programmiert, willst es aber eigentlich. Dazu gibt es im Debugger-Fenster einen Knopf mit der Aufschrift" ''create''. "Klicke ihn an."

"Du wirst nun gefragt, in welcher Klasse du die reset-Methode definieren willst - in deiner PongBall-Klasse natrlich."

"Als nchstes sollst du ein Protokoll fr die reset-Methode whlen. Whle dort ''spielsteuerung'' aus oder schreibe diesen Namen in das Eingabfeld, falls du das Protokoll noch nicht angelegt hast."

"Jetzt erscheint ein Programmierfenster mit diesem Inhalt:"
	reset
		self shouldBeImplemented 
. 
"Das ist eine erste Fassung von MSPongBall>>reset. Du knntest sie erst einmal so lassen und mit ''Proceed'' weitermachen, bis der nchste Fehler kommt, oder aber die Methode gleich in diesem Fenster programmieren und mit Alt/Strg/Cmd-s speichern. Mach das doch:

	- Lsche die eine Befehlszeile.
	- Schreibe eine Kommentarzeile.
	- bernimm aus dem Konstruktor von MSPongBall die Zeilen, 
	  in denen die Attribute wie z.B. die Geschwindigkeit auf ihre 
	  Standardwerte gesetzt werden. Im Teilfenster links unten 
	  siehst du brigens alle Instanzvariablen
	- Speichere.
	- Mach mit einem Klick auf ''Proceed'' weiter."
	
"Jetzt wiederholt sich das ganze fr den Schlger."

"Bleiben nur noch die Startpositionen, aber da gibt es ein Problem - welches knnte das sein?"

ProfStef next.'


! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/22/2011 18:18'!
pongKonstruktor13OwnerSubmorphs
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Owner und Submorphs'
	lesson:
'ProfStef previous.
ProfStef next.

"In der ersten Fassung des Pong-Konstruktors MSPong>>initialize hattest du die Zuweisung der Startpositionen so gelst:"

	"Darstellung der Figuren auf dem Spielfeld"
	ball openInWorld: self spielfeld; 
		position: self spielfeld position + (120@30).
	schlaeger openInWorld: self spielfeld; 
		position: self spielfeld position + (150@180).

"MSPong kennt das Spielfeld als Instanzvariable und konnte so mit Hilfe seiner get-Methode MSPong>>spielfeld bermitteln, um welches Spielfeld es sich handelt."

"Kennen Ball und Schlger das Spielfeld aber selbst, in dem sie ihre Startpositionen einnehmen sollen? Eigene Instanzvariablen dafr hast du nicht angelegt. Ist das notwendig?"

"Erzeuge noch einmal ein Spiel und untersuche es mit einem Inspektor:"

MSPong new inspect.

"Suche links im Baum Ball bzw. Schlger. Bei deren Attributen findet sich das PasteUpMorph des Spielfelds. Welchen Namen hat das zugehrige Attribut der jeweiligen Klasse?"

"Genau - ''owner''."

"Erinnerst du dich an die *Enthlt-Beziehung*, die *Aggregation*? Bei einem Morph stehen die Teile, die es enthlt, in den ''submorphs'', das Ganze, zu dem es gehrt, im ''owner''."

"Erzeuge in einem Workspace eine Instanz deiner Pong-Klasse und werte die nachfolgenden Zeilen dann mit ''print it'' (Alt/Strg/Cmd-p) aus. Beachte, dass du dazu die folgenden Befehlszeilen in den Workspace schreiben und sie erst mit ''accept'' (Alt/Strg/Cmd-s) speichern musst:"

"do it"
testspiel := MSPong new.
"print it"
testspiel spielfeld.
testspiel spielfeld owner.
testspiel spielfeld submorphs.
testspiel spielfeld submorphs at: 2.
(testspiel spielfeld submorphs at: 2) color.
(testspiel spielfeld submorphs at: 2) bounds.
(testspiel spielfeld submorphs at: 2) top.
(testspiel spielfeld submorphs at: 2) bottom.
(testspiel spielfeld submorphs at: 2) left.
(testspiel spielfeld submorphs at: 2) right.
(testspiel spielfeld submorphs at: 2) owner.
(testspiel spielfeld submorphs at: 2) owner extent.
(testspiel spielfeld submorphs at: 2) owner height.
(testspiel spielfeld submorphs at: 2) owner width.
(testspiel spielfeld submorphs at: 2) owner center.
(testspiel spielfeld submorphs at: 2) owner position.

(testspiel spielfeld submorphs at: 2) owner submorphs.
(testspiel spielfeld submorphs at: 2) owner submorphs at: 2.

''testspiel spielfeld submorphs at: 2'' 
"ist der Ball (vielleicht bei dir auch der Schlger), wenn man von auen auf das testspiel blickt."
.
"Aus Sicht des Spiels ist der Ball aber der zweite Submorph *seines* eigenen spielsfeldes, also"
''self spielfeld submorphs at: 2''.

"Aus Sicht des Spielfeldes ist der Ball einfach sein zweiter Submorph, also"
''self submorphs at: 2''.

"Aus Sicht des Balles (oder auch Schlgers) ist das Spielfeld dagegen sein Owner:"
''self owner''
.
"Klar, wie MSPongBall>>startPosition aussehen muss? So z.B.:"

		"Startposition des Balls im Spielfeld"
		^ self owner position + (120@30).

"oder auch:"

		"Startposition des Balls im Spielfeld"
		^ self owner position + ((self owner extent - self extent)/2)
.		
"Vergleiche das mit den Befehlen oben aus dem alten Pong-Konstruktor!!"

"Whle ein passendes Protokoll fr diese Methode und lege sie auch fr deine Schlger-Klasse an. Ergnze dann die reset-Methoden der beiden Klassen jeweils um eine Befehlszeile, mit der der Ball bzw. Schlger auf seine Startposition gesetzt wird."

"Probier aus, ob das auch klappt, und geh dann zur nchsten Lektion."
	
ProfStef next.'
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/1/2011 22:07'!
pongKonstruktor14Elemente
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Elemente'
	lesson:
'"
ProfStef previous.
ProfStef next.
"

"Zur Kontrolle: Die letzte Zeile von MSPongSchlaeger>>reset bzw. MSPongBall>>reset sollte so aussehen:

	self position: self startPosition.
"
"Der Konstruktor MSPong>>initialize sieht im Moment noch so aus:"

	"temporre Hilfsvariablen"
	| ball schlaeger |
	"Konstruktor der Oberklasse"
	super initialize.					
	"Belegung der Instanzvariablen"
	"..."				
	"Erzeugung der Figuren"
	ball := MSPongBall new.
	schlaeger := MSPongSchlaeger new.
	"Darstellung der Figuren auf dem Spielfeld"
	ball openInWorld: self spielfeld.
	schlaeger openInWorld: self spielfeld. 
	"Figuren auf Startposition"
	ball reset.
	schlaeger reset.

"Wenn noch mehr Objekte auftauchen, wird es am Ende noch mehr solcher reset-Aufrufe geben - fr jedes Objekt einen. Das geht eleganter, aber wie?"

"Erinnere dich an das Tausammler-Projekt. Dort war ein entscheidender Trick die Nachricht ''sage allen Elementen''. So etwas wre auch hier sinnvoll - nur, was sind die ''Elemente'', wie spricht man sie an?"	
	
"Morphe, z.B. das Spielfeld, kennen ihre ''Elemente''. Sie stehen in der Instanzvariablen ''submorphs''. Nun ist deine Pong-Klasse aber keine Unterklasse von ''Morph''. Daher wirst du so eine Liste der Elemente bzw. der Figuren selber anlegen mssen. Sieh dich aber vorher etwas um - vielleicht lsst sich manches von Morph abkupfern, wer wei. 
Du brauchst jetzt dabei nicht zu sehr ins Detail zu gehen. Es geht vor allem darum zu ben, wie du in Pharo Dinge erkunden kannst, die du vielleicht verwenden mchtest/musst. Listen und hnliches sind dabei etwas, das du tatschlich immer wieder bentigen wirst.   
Also los:"

"1. Was macht Morph mit seinen submorphs?"
Morph browse.
"Schmkere ein wenig in den Protokollen ''submorphs-accessing'' und ''submorphs-add/remove''. Wirf ruhig auch einen Blick auf den Quelltext der einen oder anderen Methode. Fallen dir typische Elemente/Befehlszeilen auf? Verstehst du den Programmtext teilweise schon?"

"2. Was *sind* die submorphs - welche Klasse wird dafr benutzt?"
"ffne dazu einen Inspektor fr ein Pong-Spiel von dir:"
MSPong new inspect.
"Links im Inspektor steht hinter allen Instanzvariablen auch die Klasse des aktuellen Wertes. Was steht da bei den submorphs des Spielfelds?
Suche diese Klasse im Browser. Wechsle in die Hierarchieansicht. Lies die Klassenkommentare der Klasse und ihrer Oberklassen. Wie heit die allgemeinste Klasse, mit der sich Objekte gruppieren lassen? 
Whle bei dieser Oberklasse noch einmal die Hierarchieansicht: Hier gibt es ungemein viele Unterklassen (z.B. auch ''String''!!), was zeigt, wie wichtig dieses Konzept ist - keine Angst, du wirst nur wenige davon wirklich brauchen. Dieses Fenster kannst du wieder schlieen. 
Ein besonders wichtiges Protokoll dieser Klassen ist ''enumerating''. Schau bei der obersten Klasse kurz hinein - fallen dir Methodennamen auf, die du z.B. vorher schon einmal gesehen hast?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/1/2011 21:39'!
pongKonstruktor15Kollektionen
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Kollektionen'
	lesson:
'ProfStef previous.
ProfStef next.

"Die allgemeinste Klasse, um in Smalltalk Elemente zusammenzufassen, sind *Kollektionen* (''Sammlungen''):"
Collection browse.

"Die wichtigsten Protokolle (und Methoden) von Kollektionen sind
	- creation:
		- Erzeugung mit einem (#with: ) oder 
		  mehreren (#withAll: ) Startelementen
	- adding:
		- Hinzufgen einzelner (#add: ) oder 
		  mehrerer (#addAll: ) Elemente
	- removing:
		- Lschen einzelner (#remove: ) oder 
		  mehrerer (#removeAll: ) Elemente
	- accessing: 
		- Anzahl der Elemente (#size ); 
		- Element mit einem bestimmten Index (#at: ; #at:put: )
	- testing:
		- Fllstand (#isEmpty )
		- Elementtest (#includes: )
	- enumerating:
		- Senden von Nachrichten an alle Elemente (#do: ); 
		- Sammeln von Ergebnissen aller Elemente (#collect: ; #inject:into: ); 
		- Auswahl des ersten (#detect: ) oder 
		  mehrerer (#select: ; #reject: ) Elemente mit bestimmten Eigenschaften"
		
"Die verschiedenen Arten von Kollektionen unterscheiden sich im wesentlichen nach folgenden Kriterien:
	
	- Sind die Elemente irgendwie geordnet oder durchindiziert?
	- Sind alle Elemente verschieden?
	- Ist die Anzahl der Elemente fest vorgegeben oder kann die Kollektion wachsen?"

"Es gibt zig Unterklassen von ''Collection'', in der Regel wirst du aber mit einer der folgenden auskommen:"

Array browse.
"	- ''Feld''
	- feste Elementzahl
	- mehrere gleiche Elemente erlaubt
	- Elemente von 1 bis zur Arraygre durchnummeriert
	- kann auch einfach angeschrieben werden:" 
		feld := #(''Hans'' 1 13.5 ''Elke'').
"	- Leeres Feld mit fester Gre (5 Elemente)"
		feld := Array new: 5.
"	- Fllen/Ersetzen mit einem Element an der vierten Stelle:"
		feld at: 4 put: ''Pharo''.
"	- Auslesen des dritten Elementes:"
		feld at: 3.
	
OrderedCollection browse.
"	- ''geordnete Kollektion''
	- variable Gre
	- mehrere gleiche Elemente erlaubt
	- Elemente von 1 bis zur Kollektionsgre durchnummeriert
	- Erzeugen einer leeren geordneten Kollektion:"
		liste := OrderedCollection new.
"	- Erzeugen mit einem ersten Element:"
		liste := OrderedCollection with: 42.
"	- Hinzufgen eines Elementes:"
		liste add: ''Smalltalk''.	
"	- Hinzufgen mehrerer Elemente:"
		liste addAll: #(''Smalltalk'' ''ist'' ''total'' ''lssig'').	
"	- Lschen des ersten Vorkommens dieses Elementes:"
		liste remove: ''total''.	

SortedCollection browse.
"	- ''sortierte Kollektion''	
	- wie OrderedCollection, allerdings werden hinzugefgte Elemente 
	  automatisch der Gre nach einsortiert.
	- Umwandeln irgendeiner Kollektion in eine sortierte Kollektion:"
		sortierteListe := liste asSortedCollection.	

Dictionary browse.
"	- funktioniert wie ein Wrterbuch
	- variable Gre
	- Elemente sind Schlssel-Wert-Paare (''Assoziationen'')
	- Elemente sind nicht nummeriert, sondern werden ber die Schlsselwerte identifizert
	- Schlsselwerte mssen eindeutig sein"
	
Set browse.
"	- ''Menge''
	- Gre variabel
	- Elemente nicht geordnet oder indiziert
	- alle Elemente verschieden, keine doppelten Eintrge"
	
Bag browse.
"	- ''Beutel''
	- wie Set, aber Elemente drfen mehrfach vorkommen."

"Eine dieser Kollektionen brauchst du fr die Figurenliste, in der z.B. Ball und Schlger enthalten sein sollen. Welche wrdest du whlen?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/9/2011 18:40'!
pongKonstruktor16Figurenliste
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Figurenliste, Anweisungsblcke'
	lesson:
'"
ProfStef previous.
ProfStef next.
"

"Die einfachste Form der Figurenliste wre ein Array. Der Konstruktor MSPong>>initialize she dann so aus:"

	"temporre Hilfsvariablen"
	| ball schlaeger |
	"Konstruktor der Oberklasse"
	super initialize.					
	"Belegung der Instanzvariablen"
	"..."				
	"Erzeugung der Figuren"
	ball := MSPongBall new.
	schlaeger := MSPongSchlaeger new.
	"Erzeugung der Figurenliste"
	figuren := #(ball schlaeger).
	"Darstellen und Zurcksetzen aller Figuren"
	figuren do: [:figur | 
		figur openInWorld: self spielfeld. 
		figur reset.].

"Da aber nicht klar ist, ob im Laufe des Spiels noch weitere Figuren hinzukommen, drfte eine OrderedCollection die flexiblere Lsung sein. Die letzten Zeilen des Konstruktors sehen dann so aus: "

	"Erzeugung der Figurenliste"
	figuren := OrderedCollection new.
	figuren add: ball; add: schlaeger.
	"Darstellen und Zurcksetzen aller Figuren"
	figuren do: [:figur | 
		figur openInWorld: self spielfeld. 
		figur reset.].

"Passe das bei dir entsprechend an!!"

"Kurze Erluterung der letzten drei Befehlszeilen:

''figuren'' ist eine Kollektion, die mit #do: die Nachricht erhlt, den nachfolgenden Befehlsblock (in eckigen Klammern) auszufhren.
In diesem Block wird zunchst mit :figur (beachte den fhrenden Doppelpunkt) eine *Blockvariable* ''figur'' deklariert, die nur innerhalb des Blocks bekannt ist. 
Nach dem senkrechten Trennstrich folgen die Befehlszeilen, die in dem Anweisungsblock auszufhren sind. Dabei werden fr ''figur'' der Reihe nach alle Elemente der Kollektion ''figuren'' eingesetzt - hier also Ball und Schlger."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/9/2011 19:18'!
pongKonstruktor17Accessoren
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Accessoren'
	lesson:
'ProfStef previous.
ProfStef next.

"Ball und Schlger sind jetzt zwar ber die Figurenliste ansprechbar, nicht aber direkt. Um das zu ermglichen, sind zumindest die Get-Methoden MSPong>>ball und MSPong>>schlaeger notwendig."

"Der Ball ist das erste, der Schlger das zweite Element der Figurenliste. MSPong kennt die Figurenliste als Instanzvariable und besitzt Accessoren, um darauf zuzugreifen."

"Programmiere die beiden Methoden MSPong>>ball und MSPong>>schlaeger, die jeweils das entsprechende Element der (eigenen) Figurenliste als Ergebnis zurckgeben. Sortiere die beiden Methoden in das Protokoll ''accessing'' ein."

"Tipps: Du brauchst die Figurenliste, #at: und den Rckgabeoperator. Falls du nicht mehr weit, wie der aussieht, kannst du in den Get-Methoden deiner drei Klassen nachsehen."

"Erzeuge zur Kontrolle anschlieend wieder in einem Workspace eine Instanz deiner Pong-Klasse und werte die nachfolgenden Nachrichten mit Alt/Strg/Cmd-p (''print it'') aus. Das sollte passen, d.h. du solltest angezeigt bekommen, dass es sich dabei um einen PongBall bzw. PongSchlaeger handelt!!"

testspiel := MSPong new.
testspiel ball.
testspiel schlaeger.

"Du kannst auch versuchen, Ball oder Schlaeger vom Workspace aus Nachrichten zukommen zu lassen, z.B.:"

testspiel ball color: Color red.
testspiel schlaeger position: testspiel schlaeger position + (10@0).

"Jetzt kann das Spiel allmhlich beginnen!! Rekapituliere aber zuvor noch einmal alle Teilschritte bei der Programmierung des Pong-Konstruktors, blttere noch einmal durch die siebzehn Lektionen und gehe dann erst weiter zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/12/2011 09:25'!
pongKonstruktor2Kopf
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Kopf'
	lesson:
'ProfStef previous.
ProfStef next.


"Der Konstruktor drfte jetzt erst einmal so aussehen - wie immer!!.:"

MSPong>>initialize
	"initialize the state of the receiver"
	super initialize.					"Konstruktor der Oberklasse"

"Sieh dir die Spielskizze noch einmal an:"
ObjekteKlassenTutorial zeigePongSkizze.

"Und deine Pong-Klasse (verwende *deinen* Klassennamen):"
MSPong browse.

"Als nchstes mssen alle Instanzvariablen mit sinnvollen Startwerten belegt werden. Welche Attribute hat deine Pong-Klasse? Was sind sinnvolle Startwerte?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/12/2011 09:30'!
pongKonstruktor3Instanzvariablen
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Instanzvariablen'
	lesson:
'ProfStef previous.
ProfStef next.


"Zu belegende Instanzvariablen:
	- laufend
	- spielfeld
	- figuren"
	
"Das Spiel soll nicht sofort beginnen, daher sollte ''laufend'' am Anfang sicher ''falsch'' sein. Benutze zum Belegen die Set-Methode der Variable."

"Als Spielfeld bietet sich die Klasse PasteUpMorph an:"
PasteUpMorph browse.
"Das Spielfeld braucht eine vernnftige Gre und Hintergrundfarbe und sollte sich in einem Fenster ffnen."

"Das mit dem Spielfeld probierst du am besten erst einmal in einem Workspace aus, wie du es in"
ProfStef tutorial: ObjekteKlassenTutorial lesson: #browserKategorien.
"mit einem EllipseMorph getan hast."

"Wenn du so ein passendes Spielfeld erzeugt hast, kannst du den Quelltext aus dem Workspace fast wrtlich in den Konstruktor deiner Pong-Klasse kopieren. Welchen Namen hat das Spielfeld im Konstruktor?"

"Wenn du das hast, solltest du erst einmal wieder dein Pharo-Image speichern und dann testhalber eine Instanz deiner Pong-Klasse erzeugen und mit einem Inspektor nachsehen, ob soweit alles passt:"
MSPong new inspect.

"(Teil-)Lsungen findest du in den nchsten beiden Lektionen"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/12/2011 09:33'!
pongKonstruktor4Variablenwerte
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Instanzvariablenwerte'
	lesson:
'ProfStef previous.
ProfStef next.

"Der Konstruktor sollte jetzt zumindest so aussehen.:"

MSPong>>initialize
	"initialize the state of the receiver"
	
	"Konstruktor der Oberklasse"
	super initialize.					
	"Belegung der Instanzvariablen"
	laufend := false.				
	spielfeld := PasteUpMorph new.

"Allerdings sollte das Spielfeld eigentlich bereits in der richtigen Gre und Farbe auf dem Bildschirm erscheinen. Schicke ihm die noch fehlenden Nachrichten. Sein Name ist ''spielfeld''. :-) "	

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/22/2011 16:33'!
pongKonstruktor5Spielfeld
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Spielfeld'
	lesson:
'ProfStef previous.
ProfStef next.

"Der Konstruktor sollte jetzt etwa so aussehen.:"

MSPong>>initialize
	"initialize the state of the receiver"
	
	"Konstruktor der Oberklasse"
	super initialize.					
	"Belegung der Instanzvariablen"
	laufend := false.				
	spielfeld := PasteUpMorph new.
	"Initialisierung des Spielfelds - mit einer Befehlskaskade."
	"Beachte, dass man die Hintergrundfarbe erst setzen kann, nachdem das Fenster geffnet ist."
	spielfeld extent: 600@400; 
			openInWindowLabeled: ''Mein Pong'';
			color: Color black.

"Bleiben die Figuren. Das sind im Moment der PongSchlaeger und der PongBall. Es kann aber sein, dass es spter einmal mehr werden - etwa Hindernisse, Beutestcke oder weitere Blle oder Schlger."

"Ergnze den Konstruktor um entsprechende Zeilen fr Ball und Schlger und vergleiche dann deinen Quelltext mit dem in der nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/1/2011 15:30'!
pongKonstruktor6BallSchlaeger
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Ball und Schlger'
	lesson:
'ProfStef previous.
ProfStef next.

"Im Grunde geht das mit Ball und Schlger genauso wie mit dem Spielfeld:"

MSPong>>initialize
	"initialize the state of the receiver"
	
	"Konstruktor der Oberklasse"
	super initialize.					
	"Belegung der Instanzvariablen"
	laufend := false.				
	spielfeld := PasteUpMorph new.
	"Initialisierung des Spielfelds - mit einer Befehlskaskade."
	"Beachte, dass man die Hintergrundfarbe erst setzen kann, nachdem das Fenster geffnet ist."
	spielfeld extent: 600@400; 
			openInWindowLabeled: ''Mein Pong'';
			color: Color black.
	"Erzeugung der Spielfiguren"
	ball := MSPongBall new.
	schlaeger := MSPongSchlaeger new. 

"Ergnze also deinen Konstruktor um die letzten drei Zeilen (mit *deinen* Klassennamen) und versuche deine Eingabe mit Alt/Strg/Cmd-s zu speichern. Wenn seltsame Dinge passieren, whle ''Cancel'' oder ''Abandon'' aus und lies erst einmal die nchste Lektion!!"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/1/2011 15:31'!
pongKonstruktor7UnknownVariable
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Figuren'
	lesson:
'ProfStef previous.
ProfStef next.

"Bei deinem Speicherversuch in der vorigen Lektion drfte sich ein Fenster folgenden Inhalts geffnet haben:"

	''Unknown variable: ball please correct or cancel:''
.
"Was soll das? Du hast mit ''ball'' bzw. ''schlaeger'' zwei neue Variablennamen eingefhrt, die in deiner Pong-Klasse noch nirgends erklrt worden sind."

"Das Fenster bietet dir folgende Alternativen:

	- declare temp
	- declare instance
	- eine Auswahlliste mit Altenativnamen fr den Fall, dass du dich einfach vertippt hast
	- cancel
	- ein Eingabefeld fr einen anderen Variablennamen"

"Interessant sind die beiden ersten Optionen - schlielich willst du wirklich neue Variablen mit genau diesen Namen. Was passiert jeweils?"

''declare instance''.
"Damit wird ''ball'' bzw. ''schlaeger'' eine weitere Instanzvariable des Spiels - so wie das Spielfeld. Das kann sinnvoll sein, aber Ball und Schlger gehren auch zu den Figuren, fr die es doch bereits eine Variable gibt. Das wre also doppelt gemoppelt und somit fehlertrchtig. Die Variable ''figuren'' hat spter den Vorteil, dass du damit bequem *allen Figuren auf einmal* Nachrichten wie ''start'', ''stop'' oder ''reset'' schicken kannst."	

''declare temp''
"Damit werden *temporre* oder *Hilfsvariablen* nur fr diese eine Methode (hier den Konstruktor) deklariert. Die Namen gelten dann nur innerhalb dieser einen Methode. Ist sie abgearbeitet, wei die Instanz deiner Pong-Klasse nicht mehr, was hier mit ''ball'' oder ''schlaeger'' gemeint war."

"Speichere deinen Konstruktor jetzt noch einmal und whle fr beide Variablen ''declare temp''. Sieh nach, was sich dadurch im Quelltext gendert hat, und geh dann zur nchsten Lektion."
.
ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/13/2011 17:52'!
pongKonstruktor8Hilfsvariablen
	^Lesson
	title: 'Konstruktor des ganzen Spiels - temporre Variablen'
	lesson:
'"
ProfStef previous.
ProfStef next.
"

"Der Konstruktor sollte jetzt etwa so aussehen.:"

"MSPong>>initialize hat zu Beginn eine Zeile mit temporren Variablendeklarationen erhalten. Entscheidend sind die beiden senkrechten Trennstriche:"

	"temporre Hilfsvariablen"
	| ball schlaeger |
	"Konstruktor der Oberklasse"
	super initialize.					
	"Belegung der Instanzvariablen"
	"..."				
	"Erzeugung der Figuren"
	ball := MSPongBall new.
	schlaeger := MSPongSchlaeger new.
	
"Erzeuge eine neue Instanz deiner Pong-Klasse und untersuche sie mit einem Inspektor. Findest du Ball und Schlger?"

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/1/2011 15:34'!
pongKonstruktor9OpenInWorld
	^Lesson
	title: 'Konstruktor des ganzen Spiels - Spielfeld fllen'
	lesson:
'"
ProfStef previous.
ProfStef next.
"

"Im Inspektor sind Ball und Schlger bislang nicht zu finden. Das liegt, wie beschrieben, daran, dass die Namen ''ball'' und ''schlaeger'' als temporre Variablen nur innerhalb der initialize-Methode erklrt waren. Aber gibt es diese beiden Objekte nun oder nicht?"

"Ergnze MSPong>>initialize um die letzten fnf Zeilen:"

	"temporre Hilfsvariablen"
	| ball schlaeger |
	"Konstruktor der Oberklasse"
	super initialize.					
	"Belegung der Instanzvariablen"
	"..."				
	"Erzeugung der Figuren"
	ball := MSPongBall new.
	schlaeger := MSPongSchlaeger new.
	"Darstellung der Figuren auf dem Spielfeld"
	ball openInWorld: self spielfeld; 
		position: self spielfeld position + (120@30).
	schlaeger openInWorld: self spielfeld; 
		position: self spielfeld position + (150@180).
		
"Erzeuge eine neue Instanz *deiner* Pong-Klasse und untersuche sie mit einem Inspektor:"

MSPong new inspect.

"Ball und Schlger sind jetzt im Inspektor zu finden - wo? Haben sie einen Namen?"

"Kurz eine Erklrung der neuen Befehlszeilen:"

ball openInWorld: self spielfeld. 

''Morph>>openInWorld: aWorld''."lsst einen Morph, hier also den Ball in einer Welt mit dem Namen ''aWorld'' erscheinen - genauer, der Morph wird zum Array der ''submorphs'' von ''aWorld'' hinzugefgt.
''aWorld'' darf hier irgendein PasteUpMorph sein - in unserem Fall das Spielfeld. Den Namen des Spielfelds erfhrt dein Pong, indem es seine eigene (''self'') Get-Methode" ''MSPong>>spielfeld''."aufruft."

ball position: self spielfeld position + (150@180).

''Morph>>position: aPoint''."versetzt einen Morph an den angegebenen Punkt. Punkte werden dabei in der Form ''x-Koordinate @ y-Koordinate'' angegeben. Da das ''@'' auch nur ein binrer Operator ist, mssen die Punktkoordinaten bei Rechenoperationen in Klammern gesetzt werden.
Hier soll der Ball ungefhr dorthin auf dem Bildschirm, wo sich das Spielfeld befindet - nur etwas versetzt."

"Sieh im Systembrowser nach, welche Koordinaten ein Morph als seine ''position'' liefert und schau nach, nach welchen Informationen zu seiner Geometrie man ein Morph sonst noch fragen kann."
Morph browse.

"Verndere nun deinen Pong-Konstruktor so, dass Ball und Schlger sinnvollere Startpositionen bekommen. Verschiebe die beiden etwas oder schicke sie z.B. genau in die Mitte oder an den Rand des Spielfelds. Erzeuge zur Kontrolle jeweils eine neue Instanz des Spiels."

"Erinnere dich z.B. an das Tausammlerprojekt und schau dir die fnf neuen Quelltextzeilen aus dieser Lektion noch einmal an. Was daran alles ist richtig schlecht? Es sollten dir mindestens zwei Dinge einfallen."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/22/2011 17:55'!
pongStartStop1SimpleButton
	^Lesson
	title: 'Start/Stop - SimpleButtonMorph'
	lesson:
'ProfStef previous.
ProfStef next.

"Zur Kontrolle: MSPong>>ball besteht im wesentlichen aus dieser Befehlszeile:"
	^self figuren at: 1. 

"Wie soll das Spiel gestartet oder angehalten werden? Sieh dir noch einmal die Skizze an:"
ObjekteKlassenTutorial zeigePongSkizze.

"Du siehst da einen Start/Stop-Knopf. Solche Knpfe gibt es bereits fix und fertig:"
SimpleButtonMorph browse.

"Lies den Klassenkommentar!!"

"Du findest dort folgenden Beispielaufruf:"

SimpleButtonMorph new
		target: Smalltalk;		"Objekt, an das auf Klicken reagieren soll"
		label: ''Beep!!'';			"Beschriftung"
		actionSelector: #beep; "Nachricht, die an das Objekt gesendet wird"
		openInWorld.

"Diese Befehlskaskade erzeugt einen einfachen Schaltknopf mit den angegebenen Eigenschaften und lsst ihn in der Welt erscheinen - in der linken oberen Ecke.
Fr den Start/Stop-Knopf deines Pongs sind hier ein paar Dinge anzupassen: 

	- die Beschriftung
	- die zu sendende Nachricht und der Empfnger
	- Ort und Position des Erscheinens

Die Beschriftung ist klar. 

Die Nachricht soll #startStop lauten, Empfnger der Nachricht soll dein Pong sein.

Ort des Erscheinens soll das Spielfeld sein. Wie das geht, weit du bereits. Das hast du fr Ball und Schlger auch schon programmiert. Sieh ggf. in MSPong>>initialize nach!!

Die Position musst du dann fr dich passend festlegen. Du kannst dich z.B. an den reset-Skripten von Ball und Schlger orientieren und obige Befehlskaskade um einen passenden ''position:''-Aufruf verlngern. 

Wenn du willst, kannst du dem Knopf auch noch sagen, er solle abgerundete Ecken benutzen. Die entsprechende Methode kannst du mit etwas Englisch z.B. im Methodensucher (Weltmen->Tools) finden.

Aber wo soll der Befehl zum Erzeugen des Start/Stop-Knopfes berhaupt stehen? Richtig - im Konstruktor von MSPong!!

Also schickt MSPong in seinem Konstruktor an die Klasse SimpleButtonMorph die Nachricht, einen neuen Knopf mit passender Beschriftung zu erzeugen, der an es *selbst* (self) die Nachricht #startStop schickt und in *seinem* (self) Spielfeld an geeigneter Stelle erscheint.

Da der Knopf nie von einem anderen Objekt angesprochen werden muss, ist hier keine Variable als Name ntig. Passe einfach den Beispielbefehl zur Knopferzeugung an, wie beschrieben, und fge ihn - nach einer passenden Kommentarzeile - am Ende von MSPong>>initialize an. Erzeuge anschlieend testhalber eine Instanz deines Spiels. Wenn du den Knopf nicht siehst, ffne einen Inspektor fr das Spiel und sieh nach, ob er in den Submorphs des Spielfelds enthalten ist. Passe ggf. seine Position an."

"Wenn du zufrieden bist, klicke auf den Knopf. Was dann passiert, kennst du schon - Pharo weist dich darauf hin, dass es #startStop noch nicht kennt. Aber ja, du willst die fehlende Methode in deiner Pong-Klasse erzeugen. Als Protokoll bietet sich ''spielsteuerung'' an. Speichere sie im Debugger erst einmal einfach so ab, wie sie ist:"

startStop
	self shouldBeImplemented.

"berlege dir schon einmal, was in dieser Methode eigentlich passieren soll, zeichne ein Struktogramm und geh dann zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/12/2011 21:26'!
pongStartStop2toggle
	^Lesson
	title: 'Start/Stop - toggle'
	lesson:
'ProfStef previous.
ProfStef next.

"Zur Kontrolle ein paar Bausteine zur Knopferzeugung::"
SimpleButtonMorph new
	target: self;
	actionSelector: #startStop;
	openInWorld: self spielfeld;
	position: self spielfeld position - (80@ -10).
"Beachte, dass hinter ''new'' kein Punkt oder Strichpunkt steht. ''SimpleButtonMorph new'' *ist* der Knopf, der die nachfolgenden Methodenaufrufe ausfhren soll."

"MSPong>>startStop soll zwischen laufend und angehalten umschalten und je nachdem das Spiel und seine Elemente per #reset in den Ausgangszustand versetzen oder per #start zum Laufen bringen. Im Pharo-Image gibt es viele solcher Umschaltskripte. Meist tragen sie ein ''toggle'' im Namen. Du kannst z.B. im Methodensucher nach ''toggle'' suchen und dir ein paar solcher Methoden anschauen. In vielen findest du eine Zeile folgender Form:"

	self irgendetwas: self irgendetwas not.

"Wichtig ist, dass #irgendetwas einen booleschen Wert liefert, also true oder false. Der wird mit #not in sein Gegenteil verkehrt und anschlieend mit #irgendetwas: so gesetzt. ''irgendetwas'' ist in deinem Pong ''laufend''. Also:"

startStop
	self laufend: self laufend not.

"Erzeuge ein Testspiel, ffne einen Inspektor fr das Testspiel und sieh nach, welchen Wert ''laufend'' hat. Er sollte false sein. Klicke nun im Spiel auf den Start/Stop-Knopf. Wenn du links im Inspektor den Baum zu- und wieder aufklappst oder wenn du einen neuen Inspektor ffnest, siehst du, wie links im Inspektor der Wert von ''laufend'' wechselt. Schn, aber sonst passiert noch gar nichts :-( . Was soll denn berhaupt passieren?"

"Schreib dir einen Plan auf und geh dann zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/12/2011 21:26'!
pongStartStop3startReset
	^Lesson
	title: 'Start/Stop - start und reset'
	lesson:
'ProfStef previous.
ProfStef next.

"Das Spiel und die Figuren sollen starten oder sich in den Ausgangszustand zurcksetzen. #reset kennen die Figuren schon, das Spiel aber noch nicht. #start kennt das Spiel auch noch nicht, Ball und Schlger aber schon. Diese Methode gibt es nmlich in einer Oberklasse - in welcher?"

"Lege also folgende zwei Skripte an - jeweils im Protokoll ''spielsteuerung'':"

"MSPong>>reset und MSPong>>start. In diesen beiden Skripten soll allen Figuren aus der Figurenliste gesagt werden, dass sie #reset bzw. #start ausfhren sollen. Fr #reset hast du genau so etwas schon einmal im Konstruktor deiner Pong-Klasse programmiert. Sieh dort nach!!"

"Zum Testen kannst du folgendes machen: Erzeuge in einem Workspace ein Testspiel:"
testspiel := MSPong new.
"Verschiebe dann mit der Maus Ball und Schlger im Spielfeld und schicke dem Spiel anschlieend vom Workspace aus die Nachricht"
testspiel reset.
"Jetzt sollten die Figuren wieder an ihre Startpositionen zurckkehren."

"Wenn du das geschafft hast, geh zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/22/2011 17:59'!
pongStartStop4Verzweigung
	^Lesson
	title: 'Start/Stop - Verzweigung'
	lesson:
'ProfStef previous.
ProfStef next.

"Gefunden?"
figuren do: [:figur | 
	figur machEtwas.
	figur machNochEtwas.].

"#reset und #start mssen von #startStop noch aufgerufen werden. Dazu bedarf es einer Verzweigung:"

"Wenn das Spiel luft, dann soll es #reset ausfhren, sonst #start."

"In Smalltalk haben Verzweigungen folgende Syntax:"

(bedingung)				"Beachte die Klammern!!"
	ifTrue: [dannBlock.]
	ifFalse: [sonstBlock.].	"Gib auf den Punkt am Ende hinter der Klammer acht!!"
		
"''bedingung'' muss dabei irgendein Ausdruck sein, der einen der booleschen Wahrheitswerte true oder false liefert. Hier ist das"
self laufend.

"Also sieht der fehlende Befehl in MSPong>>startStop so aus:"

(self laufend)
	ifTrue: [self reset]
	ifFalse: [self start].

"*Danach* muss der Wert von ''laufend'' noch umgeschaltet werden:"

self laufend: self laufend not.

"Erzeuge zum Testen eine Spielinstanz, verschiebe Ball und Schlger mit der Maus und klicke dann mit dem Mauszeiger mehrmals auf den Start/Stop-Knopf. Passiert etwas? Wann? Klar, warum?"

"Jetzt wird es aber an der Zeit, dass sich Ball und Schlger endlich bewegen bzw. steuern lassen. Fr den Ball brauchst du die Methode kleiner Schritte, die du vermutlich aus dem Physik-Unterricht kennst. Informiere dich ggf. darber und gehe dann zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/13/2011 17:49'!
pongStep1PhysikSchritte
	^Lesson
	title: 'Physik - Methode kleiner Schritte'
	lesson:
'ProfStef previous.
ProfStef next.

"Fr physikalische Bewegungssimulationen mit der Methode kleiner Schritte bentigst du im wesentlichen folgende drei Gleichungen:

	- Beschleunigung 			= Kraft / Masse
	- neue Geschwindigkeit 	= alte Geschwindigkeit + (Beschleunigung * Zeitschritt)
	- neue Position 				= alte Position + (Geschwindigkeit * Zeitschritt)
					
Falls die (resultierende) Kraft nicht konstant ist, muss auch sie nach jedem Schritt neu berechnet werden. Das kann dann etwas komplizierter werden."

"Dein Ball bewegt sich aber in einem homogenen Schwerefeld. Seine Beschleunigung ist konstant: a= (0@10) oder so hnlich. Damit entfllt fr die Beschleunigung die Berechnung. Die y-Komponente der Beschleunigung ist positiv, weil in Smallltalk - wie in den meisten Programmiersprachen - die Koordinatenachsen von links nach rechts und von oben nach unten laufen."

"So noch nicht geschehen, lege fr deine PongBall-Klasse ein Protokoll ''physik'' an. Darin brauchst du folgende drei Methoden:"

aktualisiereBeschleunigung
	"konstante Beschleunigung (Schwerkraft)"
	self a: (0@10).
	
aktualisiereGeschwindigkeit
	"Methode kleiner Schritte"
	self v: self v + (self a * self dt).
	
aktualisierePosition
	"Methode kleiner Schritte"
	self position: self position + (self v * self dt).
	
"Beachte die Klammern. Smalltalk kennt kein Punkt vor Strich!!"
	
"Diese drei Methoden mssen jetzt nur noch in regelmigen Zeitschritten aufgerufen werden. Dazu kennt die Klasse Morph genau das passende Konzept: *stepping*."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/13/2011 17:48'!
pongStep2Morph
	^Lesson
	title: 'Morph - Stepping'
	lesson:
'ProfStef previous.
ProfStef next.

"Fast alle fr ''stepping'' relevanten Methoden finden sich bei Morphen im Protokoll ''stepping and presenter'':"
(OBSystemBrowser onClass:  Morph category:  ''stepping and presenter'') open.

"Wichtig sind folgende vier Methoden:"

"#step enthlt alle Befehle, die in regelmiger Wiederholung ausgefhrt werden sollen:"
(OBSystemBrowser onClass:  Morph selector:  #step) open.

"#stepTime liefert als Wert die Zeitspanne in MIllisekunden, die zwischen den einzelnen Schritten verstreichen soll:"
(OBSystemBrowser onClass:  Morph selector:  #stepTime) open.

"#start verwendest du schon - erinnere dich an MSPong>>startStop. Damit wird die wiederholte Ausfhrung von #step gestartet:"
(OBSystemBrowser onClass:  Morph selector:  #start) open.

"#stop beendet die wiederholte Ausfhrung von #step:"
(OBSystemBrowser onClass:  Morph selector:  #stop) open.

"Was musst du tun?

1. Programmiere MSPongBall>>step

Darin muss der Reihe nach Beschleunigung, Geschwindigkeit und Position aktualisiert werden. Die Methoden dafr hast du in der letzten Lektion programmiert. (Vergiss ''self'' nicht!!)

2. berschreibe Morph>>stepTime mit MSPongBall>>stepTime

MSPongBall>>stepTime sollte den gleichen Wert liefert wie MSPongBall>>defaultDeltaT - allerdings in Millisekunden. MSPongBall>>defaultDeltaT liefert bei dir im Moment vermutlich 0.01 (s). Schreibe in die stepTime-Methode daher keine Zahl, sondern die Umrechnung von defaultDeltaT in MIllisekunden. (Vergiss ''self'' und den Rckgabeoperator nicht!!)

3. Sorge dafr, dass in MSPongBall>>reset als allererstes #stop aufgerufen wird, damit der Ball ggf. auch stehen bleibt. (Vergiss ''self'' nicht!!)

Die beiden ersten Methoden sortierst du am einfachsten automatisch in passende Protokolle ein, nachdem du sie zuvor im Protokoll ''-- all --'' erzeugt oder dorthin verschoben hast."

"Wenn du das hast, probier es aus!! Du musst nur in deinem Pong auf den Start/Stop-Knopf klicken. Der Ball sollte jetzt fallen und auch wieder an seine Startposition zurckkehren und dort verharren. Falls er sich zu langsam bewegt, musst du den Wert der Beschleunigung in MSPongBall>>aktualisiereBeschleunigung anpassen, etwa auf (0@100) oder (0@1000). Das wird etwas von der Rechenleistung deines Computers abhngen."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/22/2011 19:04'!
pongStep3AbprallenLogik
	^Lesson
	title: 'Abprallen und logische Operatoren'
	lesson:
'ProfStef previous.
ProfStef next.

"Zur Kontrolle: 
- MSPongBall sollte jetzt die beiden neuen Protokolle ''testing'' und ''stepping and presenter'' besitzen.
- MSPongBall>>stepTime sollte etwa so aussehen:"''
	stepTime
		^self defaultDeltaT * 1000.
''."
- MSPongBall>>step sieht so aus:"''
	step
		"Methode kleiner Schritte" 
		self aktualisiereBeschleunigung.
		self aktualisiereGeschwindigkeit.
		self aktualisierePosition.
''.
"Schade nur, dass der Ball aus dem Fenster ''herausfllt'', statt am Rand abzuprallen. Auch der Schlger stellt bislang kein Hindernis fr ihn dar. Du kannst es ausprobieren, indem du den Schlger dem Ball mit der Maus in den Weg legst."

"Was tun? Erst einmal berlegen und planen!!

1. Was bedeutet ''abprallen''?

Genau - die Geschwindigkeit muss sich umkehren. 
Genauer: 
a) Wenn der Ball den linken oder rechten Spielfeldrand trifft, muss die x-Koordinate der Geschwindigkeit ihr Vorzeichen wechseln.
b) Wenn der Ball den oberen oder unteren Spielfeldrand trifft, muss die y-Koordinate der Geschwindigkeit ihr Vorzeichen wechseln.
c) Wenn der Ball den Schlger trifft, muss die y-Koordinate der Geschwindigkeit ihr Vorzeichen wechseln.
Noch genauer und schon etwas nach vorne gedacht:
- Wenn der Ball den Schlger trifft, bekommt der Schlger einen Punkt.
- Wenn der Ball den unteren Spielfeldrand trifft, hat der Schlger einen Fehler gemacht.

2. Wie verndert man das Vorzeichen einer Geschwindigkeitskomponente?

Nun, du benutzt fr Beschleunigung, Geschwindigkeit und Position Ausdrcke der Form (x@y), also Instanzen der Klasse Point.
Diese haben Attribute ''x'' und ''y'', die sich mit entsprechenden Accessoren ansprechen lassen. 
Fr den Vorzeichenwechsel gibt es z.B. die Nachricht #negated. Also etwa:"

self v: (self v x negated @ self v y).
"

3. Was bedeutet ''treffen''?

Richtig - berlappen auf dem Bildschirm
Genauer:
- Jeder Morph kennt seine #bounds.
- Konkret kann man jeden Morph z.B. auch nach den vier Kanten oder Ecken des Rechtecks fragen, das ihn umrahmt.
- Die relevanten Methoden findest du im Protokoll ''geometry'' der Klasse Morph:"
(OBSystemBrowser onClass:  Morph category:  ''geometry'') open.
"
4. Wie berprft man das berlappen?

Genau: durch Vergleich der Koordinaten der relevanten Kanten, also etwa:"
objekt1 bottom > objekt2 top. "Beachte, dass die y-Koordinate von oben nach unten luft!!"
"
Ergebnis ist ein boolescher Wahrheitswert: true oder false.

5. Wie kombiniert man solche Vergleiche?

Du brauchst z.B. so etwas:
- zu weit links *oder* zu weit rechts
- zu weit unten *und* zwischen linkem und rechtem Rand des Schlgers

Dazu gibt es logische Operatoren:"
(OBSystemBrowser onClass: Boolean category:  ''logical operations'') open.
"
- & steht fr ''und''.
- | steht fr ''oder''.
- not steht fr ''nicht''
- Beachte, dass du viele runde Klammern () brauchen wirst!!
- Z.B. sollte der *gesamte* logische Ausdruck auch in runden Klammern stehen.

Beispiele:
- nicht zu weit links:"
((objekt1 left < objekt2 left) not) "Beachte, dass not nachgestellt wird - es ist eine Nachricht"
."
- zu weit oben oder zu weit unten:"
((objekt1 top < objekt2 top) | (objekt1 bottom > objekt2 bottom))
."
- zwischen linkem und rechtem Rand:"
((objekt1 left > objekt2 left) & (objekt1 right < objekt2 right))
."
Damit kannst du schon einmal die Methode MSPongBall>>pralleAmRandAb programmieren.
	- Ordne sie im Protokoll ''physik'' ein.
	- objekt2 ist hier das Spielfeld. Welchen Namen hat das fr den Ball?
	- Sieh wegen des Namens ggf. in MSPongBall>>startPosition nach.
	- Kmmere dich um oben-unten *und* um links-rechts.
	- Die Methode muss natrlich in MSPongBall>>step aufgerufen werden!!
Probiere das Ergebnis aus, indem du in deinem Testspiel den Start/Stop-Knopf bettigst.

Falls der Ball immer weniger hoch springt, hilft es, in #pralleAmRandAb am Ende #aktualisierePosition aufzurufen. Dadurch springt der Ball sofort schon einen Schritt weit zurck."

"Fr das Abprallen am Schlger gibt es noch ein Problem. Welches knnte das sein? Schreib deine Vermutung auf und geh dann zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/23/2011 00:12'!
pongStep4Namensketten
	^Lesson
	title: 'Wer kennt wen bzw. wessen Namen?'
	lesson:
'ProfStef previous.
ProfStef next.

"Wer bitte ist der Schlger? Kann ihn der Ball ansprechen? Kennt der Ball einen Namen fr den Schlger?"

"Nein - Das geht allenfalls um eine Ecke:

	- Das Spielfeld kennt den Schlger als ein Element seiner submorphs.
	- Wenn du nachsiehst, wird der Schlger wahrscheinlich das zweite Element sein.
	- Der Ball kennt das Spielfeld als seinen owner.

Damit wre der Schlger dann fr den Ball unter folgendem Namen ansprechbar:"

self owner submorphs at: 2
.
"Wenn du willst, kannst du das ausprobieren. Erzeuge in einem Workspace ein Testspiel und ffne einen Inspektor fr den Ball:"

testspiel := MSPong new.
testspiel ball inspect.

"Sieh im Inspektor nach, welche Nummer der Schlger in den submorphs des owners hat - wahrscheinlich 2."

"Im Inspektor kannst du dann z.B. das hier versuchen:"
self owner submorphs at: 2. 					"print it"
(self owner submorphs at: 2) color: Color blue. 	"do it"

"Aber - Ist es sicher die Nummer 2?

- Hebe den Schlger mit dem Mauszeiger aus dem Spielfeld heraus und lege ihn irgendwo anders im Pharo-Fenster ab.
- Schliee den Inpektor.
- Lege den Schlger wieder in das Spielfeld zurck.
- ffne erneut einen Inspektor.
- Welche Nummer hat der Schlger jetzt?"

"Problem erkannt? Du hast diese Nummer als Programmierer nicht sicher in der Hand. Ein Benutzer kann sie (versehentlich) vendern."

"Was tun? Es gibt die Figurenliste, und - besser noch - das Spiel kennt den Schlger. Dazu hast du eigens die Get-Methode MSPong>>schlaeger programmiert."

"Leider kennt der Ball aber das Spiel nicht - auch das Spielfeld kennt das Spiel nicht. Das erweist sich nun als Fehler in der Planung. Also - Refactoring!!"

"Das Spielfeld ist keine eigens von dir angelegte Klasse, weshalb du es nicht verndern solltest. Bleibt der Ball - der muss das Spiel kennen und ansprechen knnen."

"Schreib dir eine Liste zusammen, was dafr alles verndert werden muss: Welche Methoden/Variablen mssen neu angelegt werden, welche sind zu verndern? Wenn du die Liste hast, geh zur nchsten Lektion."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/23/2011 00:17'!
pongStep5Refactoring
	^Lesson
	title: 'Spiel - Refactoring'
	lesson:
'ProfStef previous.
ProfStef next.

"Damit der Ball das Spiel kennt, sollte folgendes zu erledigen sein:

- MSPongBall braucht eine weitere Instanzvariable ''spiel''.
- Die Accessoren #spiel und #spiel: sind ntig. 
	(Am einfachsten ber das Kontextmen und ''refactor class'')
- Fr ''spiel'' gibt es keinen sinnvollen Standard- oder Startwert.
	- Also ist in MSPongBall>>initialize und MSPongBall>>reset nichts zu ndern.
	- Der Wert bleibt erst einmal nil.
- Eine Anpassung ist im Konstruktor des ganzen Spiels ntig, in MSPong>>initialize:
	- Dort muss dem ''ball'' gesagt werden, wer sein Spiel ist: self!!
	- Ergnze in MSPong>>initialize gleich nach der Erzeugung des Balls diese Zeile:"
	ball spiel: self.
		
"Genau das gleiche solltest du auch fr den Schlger machen, da zu erwarten steht, dass dort hnliche Probleme auftreten."

"Erzeuge ein neues Testspiel und sieh im Inspektor nach, ob nun Ball und Schlger das Spiel kennen!!"

"Wenn du das hast, kannst du am Ende von MSPongBall>>step noch diesen Befehl ergnzen:"

self pralleAbVon: self spiel schlaeger.

"Klar, was diese Zeile bedeutet? Beim Speichern wirst du den Namen #palleAbVon: eigens besttigen mssen."

"Speichere dein Image wieder einmal und auch dein Monticello-Paket. Erzeuge dann ein neues Testspiel und starte es. Wenn du alles richtig gemacht hast, sollte sich de Debugger ffnen und das Fehlen von #pralleAbVon: bemngeln."

"Erzeuge diese Methode (z.B. mit Create im Debugger) und programmiere sie. Bei Bedarf findest du in der nchsten Lektion Hilfe dazu."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/22/2011 23:46'!
pongStep6AbprallenVon
	^Lesson
	title: 'Abprallen von - Methoden mit Parameter'
	lesson:
'ProfStef previous.
ProfStef next.

"Zur Kontrolle: MSPongBall>>pralleAmRandAb sollte etwa so aussehen:"''
	pralleAmRandAb 
		"physikalisch richtiges Abprallen am Spielfeldrand"
		((self left < self owner left)|(self right > self owner right))
			ifTrue:[self v: (self v x negated @ self v y)].
		((self top < self owner top)|(self bottom > self owner bottom))
			ifTrue:[self v: (self v x @ self v y negated)].
		self aktualisierePosition.
''."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 3/22/2011 23:47'!
pongStep7AbprallenVonAllenAnderen
	^Lesson
	title: 'Abprallen von allen anderen - Identittsprfung und Listenelemente'
	lesson:
'ProfStef previous.
ProfStef next.

"Zur Kontrolle: MSPongBall>>pralleAmRandAb sollte etwa so aussehen:"''
	pralleAmRandAb 
		"physikalisch richtiges Abprallen am Spielfeldrand"
		((self left < self owner left)|(self right > self owner right))
			ifTrue:[self v: (self v x negated @ self v y)].
		((self top < self owner top)|(self bottom > self owner bottom))
			ifTrue:[self v: (self v x @ self v y negated)].
		self aktualisierePosition.
''."

"Statt nur vom Schlger, von allen anderen Figuren:"
self spiel figuren do: [:figur|
	(figur == self) ifFalse: [self pralleAbVon: figur.].
	].

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:04'!
refactoring
	^Lesson
	title: 'Refactoring'
	lesson:
'ProfStef previous.
ProfStef next.

"Es ist durchaus nicht ungewhnlich, dass sich im Laufe der Projektentwicklung Verbesserungsbedarf an der einen oder anderen Stelle ergibt. Mal hat einfach nur eine Instanzvariable, Methode oder Klasse den falschen Namen, mal hat aber auch eine Klasse zu viele Funktionalitten, die besser auf mehrere spezialisierte Klassen verteilt werden sollen."

"Derartige Verbesserungen nennt man ''Refactoring''."

"Ein groes Problem besteht dann z.B. darin, dass die vorhandenen Namen bereits an verschiedenen Stellen benutzt werden und folglich berall ausgebessert werden mssten. Damit das nicht uferlos wird, bieten hier Entwicklungsumgebungen wie pharo gute Hilfe."

"An dieser Stelle erst einmal nur der kurze Hinweis: Rechtsklick auf einer der Listen im Browser bietet im Kontextmen eine Reihe vpn Eintrgen zum Refactoring. Wenn du mit dem Mauszeiger eine Weile ber einem Meneintrag verweilst, erscheint in der Regel auch ein Hilfetext dazu."

"Wer wei, vielleicht werden wir das auch bei diesem Projekt noch brauchen. Erst einmal klren wir aber die Frage, wie du dein Projekt so abspeichern kannst, dass es auch andere bentzen knnen."

ProfStef next.'.
! !

!ObjekteKlassenTutorial methodsFor: 'tutorial' stamp: 'MarkusSchlager 3/22/2011 23:48'!
tutorial
	^#( 
	#intro 
	#oeffneWerkzeuge 
	#planePong 
	#browserUeberblick 
	#browserKategorien 
	#browserKlassen1 
	#browserInstanzen 
	#browserKlassen2 
	#browserKlassen3 
	#erzeugeUnterklassen 
	#kommentiereKlassen
	#inspektoren
	#erzeugeAttribute 
	#erzeugeAccessoren 
	#browserProtokolle 
	#browserMethoden 
	#browserMethodenUeberschreiben 
	#defaultMethoden
	#wertNil
	#browserSenderImplementoren
	#initializeMethode
	#fazitKlassenAnlegen
	#refactoring
	#monticelloBrowser
	#pongKonstruktor1
	#pongKonstruktor2Kopf
	#pongKonstruktor3Instanzvariablen
	#pongKonstruktor4Variablenwerte
	#pongKonstruktor5Spielfeld
	#pongKonstruktor6BallSchlaeger
	#pongKonstruktor7UnknownVariable
	#pongKonstruktor8Hilfsvariablen
	#pongKonstruktor9OpenInWorld
	#pongKonstruktor10Datenkapselung
	#pongKonstruktor11Reset
	#pongKonstruktor12MessageNotUnderstood
	#pongKonstruktor13OwnerSubmorphs
	#pongKonstruktor14Elemente
	#pongKonstruktor15Kollektionen
	#pongKonstruktor16Figurenliste
	#pongKonstruktor17Accessoren
	#pongStartStop1SimpleButton
	#pongStartStop2toggle
	#pongStartStop3startReset
	#pongStartStop4Verzweigung
	#pongStep1PhysikSchritte
	#pongStep2Morph
	#pongStep3AbprallenLogik
	#pongStep4Namensketten
	#pongStep5Refactoring
	#pongStep6AbprallenVon
	)! !

!ObjekteKlassenTutorial methodsFor: 'lessons' stamp: 'MarkusSchlager 2/6/2011 10:04'!
wertNil
	^Lesson
	title: 'Fehlende Werte - nil'
	lesson:
'ProfStef previous.
ProfStef next.

"So ganz befriedigend ist das ja noch nicht:"

MSPongBall new inspect.
MSPongSchlaeger new inspect..

"Wie du siehst, haben Instanzen der beiden Klassen zwar alle gewnschten Attribute, aber der zugwiesene Wert ist ''nil''."

"''nil'' bedeutet ''nichts'' (in anderen Programmiersprachen heit es ''none'' oder ''null'') und meint eben, dass etwas keinen Wert hat. Oft muss man wissen, ob etwas schon einen Wert hat oder nicht (erinnere dich etwa an das Problem, ob der Kfer im Tausammler-Projekt schon einen Passagier hatte). Deshalb gibt es auch eine Testnachricht ''isNil''. Fhre z.B. bei folgender Zeile ''print it'' oder Alt/Cmd/Strg-p aus:"

PongBall new m isNil.

"Wie man ''isNil'' oft benutzt, kannst du z.B. bei Morph>>formerPosition: sehen, der Methode, mit der ein Morph seine vorige Position verwaltet, wenn er bewegt wird:"

OBSystemBrowser openOnClass: Morph selector: #formerPosition: .

"Bei der Gelegenheit siehst du auch eine zweiseitige Verzweigung in Smalltalk (''wenn - dann - sonst''):"

eineBedingung
	ifTrue:  [dannBefehle ] 
	ifFalse: [sonstBefehle]
.
"Merke dir die eckigen Klammern fr die Anweisungsblcke!!"

"So, aber wie kommen nun die Attribute zu ihren Standardwerten?"

ProfStef next.'.
! !
